//---------------------------------------------------------------------------
#include <vcl.h>
#include <Clipbrd.hpp>
#pragma hdrstop
#include <dir.h>
#include <io.h>
#include <fcntl.h>
#include <share.h>
#include <shellapi.h> //DragDropt@C擾֌W
#include "midmain.h"
#include "midplay.h"
#include "fmcomp.h"  /* pwb_ */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "midgoto.h"
#include "mid_logo.h"
#include "mid_opt.h"
/*#include <io.h>*/
#pragma link "HTMLHelpViewer"
//---------------------------
#define COPYR "(C)2000-2002,2013,2017 wnc / t.w."
#define MDCVER "mdcomp32 v1.01"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

// cfg size
#define CFGSIZE 512 //byte

/* dos ver MAX 512 (32bit ver:2000) */
#define LINEMAX 2000    /*Ps̍ő*/
#define EXECMAX 10       /*R[h̐ rev<20020114p>*/

/* dos ver MAX 64000 (32bit ver:65536) */
#define CH_MEMMAX 64000+3  /*e`l̊mۃ̈*/
#define LEN_MAX 16      /*̃e[umې*/

/* dos ver MAX 65002 (32bit ver:65536) */
#define FMDMEMMAX 65002  /*fmdata̍ő*/

/* max line count (Turbo C 2.01(eng) ver:999999)<20010115a> */
#define MAXLINECNT 999999

/* max rich edit size 1Mbyte <20010214a> */
#define MAXREDSIZE 1000000

/* <20010114p> ő`l */
#define MAX_CH 9

/* <20010120a> őyԍ */
#define MAXGAKKI 127

/* <20010115p> ő剹ʐ (RpCf[^ł) */
#define MAX_VOLUME 16

/* <20010321p> q ̍ő` */
#define MAX_Q 8
#define Q_DEF 7   // q ̏l( Q8 (l7)) 88FH,MH݊

/* <20010830p> Panpot֌W($) */
#define MAX_PAN 127
#define PAN_DEF 64
#define MIN_PAN 0

/* tempo */
#define TEMPO 120  /*midiϊp*/
#define MIN_TEMPO 10 /* midi ϊp */
#define MAX_TEMPO 250 /* midi ϊp */

/* midi key adjust L[fmcompl𑝂₳ȂĂ͂Ȃ */
#define MID_ADJUST 23 /* (24łȂ̂ 0͖:fmcomp) */

/* Awp v0.00.05 */
#define MAX_RENPU 32  /* A̍ő <20010325p> */


/* ݒ\[XύX邽 */
#define OP_Q7DEF 1   /* opߗp v0.00.08 <20010907p> */
#define OP_Q8DEF 2   /* opߗp v0.00.08 <20010907p> */
#define OP_AUTOLR 3  /* opߗp v0.00.08 <20010907p> */
#define OP_MANULR 4  /* opߗp v0.00.08 <20010907p> */
#define OPSETWORK 20 /* opߗpƗ̈傫 v0.00.08 <20010907p> */

/* 쌠񒷂ő crߊ֌W */
#define COPYRMAX 63 /* crߗp v0.00.09 <20011231p> */

/* V[PX񒷂ő snߊ֌W */
#define SNAMEMAX 127 /* snߗp v0.00.10 <20020114p> */

//obNAbv֌W (GUI) v0.00.10a <20020610a>
#define IDLATBTIM 5    // 5bԂ͗V
#define ATBAKTIM  180  // 180bƂɎobNAbv

//S֘A(20130219)v0.00.11
//#define O4BK 32   //l\
//v1.01.00(20170906) l480֕ύX
#define O4BK 480   //l\
#define O4TBK (O4BK*1.5)  //l.\
#define OXBK (O4BK*8)   //?\
#define O1TBK (O4TBK*4)   //S.\
#define O1BK (O4BK*4)   //S\
#define O2TBK (O4TBK*2)   //񕪉.\
#define O2BK (O4BK*2)   //񕪉\
#define O8TBK (O4TBK/2)   //.\
#define O8BK (O4BK/2)   //\
#define O16TBK (O8TBK/2)  //16.\
#define O16BK (O8BK/2)  //16\
#define O32TBK (O16TBK/2) //32.\
#define O32BK (O16BK/2) //32\
#define O64TBK (O32TBK/2)  //64.\
#define O64BK (O32BK/2)  //64\
#define O128TBK (O64TBK/2) //128.\
#define O128BK (O64BK/2) //128\

#define FMO4 32  //l(fmcompf[^)

//rd1lineG~[V邽߂̕ϐ
//int RdFilePtr;
int RdFileLineCnt;  //<20010204p> rd1lineG~[^p

char midfname[MAXPATH];   /* <20010119a> */
char bmidfname[MAXPATH]; /* <20010119a> */
char sourcefname[MAXPATH]; /* <20010119a> */

int f_rd_open;
static int ch_stack = 0;  /*I[vchL^*/

unsigned long chxcnt[MAX_CH]; /* L^ʒu <20010120p> */
unsigned char *chxmem[MAX_CH]; /* mۂԒni[p */

static int okutabu_ch[MAX_CH]; /* IN^[uL^ <20010114p> */
static int length_ch[MAX_CH];  /* L^(cde͂ŕύX) <20010114p> */
static int volume_ch[MAX_CH];  /* ʋL^(cde͂ŕύX) <20010114p> */
static int q_ch[MAX_CH];       /* 鎞Ԃ̊(q)<20010321p>*/
//static int pan_ch[MAX_CH];     /* Panpot($)<20010830p> */

//static char fmdname[512];  /*^[Qbgnamei[*/
unsigned long rd_linecount;  /*ǂݍ񂾍s*/

int chxlen[MAX_CH]; /* RpCʁiSji[p<20010127p>*/

bool f_save = false;  /* false = no, true = saveł */
bool f_saveend = true; /* false = ܂ true =  */
bool f_smfcreate = false; /* false = tmp , true = user */
bool f_tmpcreate = false; /* false = no,  true = created */
bool f_remskip = false; //<20010126a>RgJnƏI
bool f_errcreate = false; /* false = Ȃ true=ERR */
bool f_CloseCancel = false; // DragDrop OpenCancelp<20011231p>v0.00.09
bool f_nomidiout = false;  //truemidio͂Ȃ<20170907p>v1.01.00

bool f_autosave = false; //CheckBox1㏑ۑ
bool f_playloop = false; //CheckBox2t[v
bool f_numberon = false; //CheckBox3sԍ\
bool f_form_max = false; //CheckBox4ʍő剻
bool f_q_def7   = false; //RadioGroup2  88VA݊H <20010322a>v0.00.05
bool f_auto_lr  = false; //CheckBox5Ez <20010906p>v0.00.07
int  fontsize_r = 0;     //tHg̃TCYL^(0=,1=,2=)

int f_storetmp = 0; /* e|xނ rev<20010321p>*/
int ch_run_ex;        /* ݏłch̔ԍi[ <20010321p> */

int work_len[MAX_RENPU];  /*Ap <20010326a> v0.00.05 */
char work_key[MAX_RENPU];

char copyr_work[COPYRMAX+1];  /* 쌠p <20011231p> v0.00.09 */
int copyr_len;            /* 쌠̒ <20011231p> v0.00.09 */
bool f_copyr_sw = false; /* false=쌠͂Ȃ <20011231p> v0.00.09 */

char sname_work[SNAMEMAX+1];  /* V[PXp <20020114p> v0.00.10 */
int sname_len;           /* V[PX <20020114p> v0.00.10 */
bool f_sname_sw = false; /* false=V[PX͂Ȃ <20020114p> v0.00.10 */

bool f_autobak = false;  /*baksH(true=y)<20020610p> v0.00.10a(GUI)*/
int abaksttim;      /* backupJn܂ł̗V <20020610a> v0.00.10a (GUI)*/
int abaktim;        /* backupԊu <20020610a> v0.00.10a (GUI) */
int tmp_hand = -1;  // backupphandle <20020610p> v0.00.10a (GUI)
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
	//obNAbv(GUI) <20020611a> v0.00.10a
	abaksttim = IDLATBTIM; //
    abaktim   = ATBAKTIM;  //

	OverWrite = false; //reset

	//ʂIƂɌĂяo
	Application -> OnIdle = IdleHandler;

    if(RdCfgData())  //cfgf[^o(ret false=ǂ߂,true=ǂ߂)
    {   //ǂ߂ȂƂ
        //ݒ
        f_autosave = false; //CheckBox1㏑ۑ
        f_playloop = false; //CheckBox2t[v
        f_numberon = false; //CheckBox3sԍ\
        f_form_max = false; //CheckBox4ʍő剻
        f_auto_lr  = false; //CheckBox5Ez v0.00.07
        fontsize_r = 0;     //tHg̃TCYL^(0=,1=,2=)
    }

// C++Builder5 ŃoO邽FormCreateړ
//ݒ𔽉f(cfgŕۑĂꍇ܂)
    if(f_autosave == true){   N16->Click();}   //㏑ۑ
    if(f_playloop == true){   N13->Click(); }  //t[v
    if(f_numberon == true){   N17->Click(); }  //sԍon
    if(f_form_max == true){   WindowState=wsMaximized;} //ő剻
    if(f_auto_lr  == true){   S1->Click();} //Ez

    switch(fontsize_r)
    {
        case 0: N8p1->Click() ;break; //
        case 1: N10p1->Click() ;break; //
        case 2: N12p1->Click();break; //
        default:N8p1->Click();
    }

	Memo1 -> Lines -> Clear();  //<20020212p>win2000


	//--<20020610p> obNAbvp v0.00.10a (GUI)---
	//tmptH_擾
    AnsiString f1;
    char tmppath[MAX_PATH+2];
    if(GetTempPath(MAX_PATH,tmppath)<=0)
    {
    	//TempPathG[̏
    }
    f1=tmppath;
    f1+="!!mdcomp32.tmp";

	//debug
	//ShowMessage("tmp::"+f1);

    //(tmp)\!!mdcomp32.tmpI[v
	//open

	int retv = access(f1.c_str(), 0); //file݂邩ǂ

	int retv2;
    if((retv2 = _rtl_open(f1.c_str(),O_RDONLY))>=0)
    {
    	_rtl_close(retv2);
		retv2 = 0;  //sI̋^
    }


    if(retv == 0 && retv2 == 0) //݂
    {
		//sI
		int RetValue = Application -> MessageBox("backupfile܂\n"
        	"ǂݍ݂܂H","mF",MB_ICONQUESTION | MB_YESNO);

		if(RetValue == IDYES)
	    {
			Memo1->Lines->LoadFromFile(f1.c_str());
		}
    }
	else if(retv != 0)         //݂Ȃ
    {
		//VK쐬
		if ((tmp_hand = _rtl_creat(f1.c_str(),0)) >= 0)
        {
        	//쐬
			f_autobak = true;   //backupJn
        }
		else
        {
        	//s
        	f_autobak = false;  //backup~
		//	Panel1->Color = clAppWorkSpace; //Fς
        }
		_rtl_close(tmp_hand);
    }
	else
    {
    	f_autobak = false;
	//	Panel1->Color = clAppWorkSpace; //Fς

        Application->MessageBox("łmdcomp32N\n"
        			            "Nmdcomp32\n"
                    "backup͍쓮܂.",NULL,MB_ICONSTOP);
    }


	if ((tmp_hand = _rtl_open(f1.c_str(), O_RDONLY | SH_DENYRW)) >= 0)
	{
    	//openł
		f_autobak = true;
	}
	else
    {
		//openłȂ
    	f_autobak = false;  //backup~
	//	Panel1->Color = clAppWorkSpace; //Fς
    }

	//fmcompf[^o͗p
	fmdat = new TMemoryStream;   //m
	fmdat->Clear();

    //---------------------------------------------------
}
//---------------------------------------------------------------------------


void __fastcall TForm1::about1Click(TObject *Sender)
{
	AnsiString as1;
	as1 = MDCVER "\n" COPYR "\nAll rights reserved.";
	Application->MessageBoxA(as1.c_str(),"o[W",MB_OK);
}
//---------------------------------------------------------------------------
//-------^Cg\邽߂̏
void __fastcall TForm1::IdleHandler(TObject *Sender, bool &Done)
{
	Application->OnIdle = NULL; //oO

    Form1 -> Tag = 1;  //I邽߂̒l(logoformŎgp)

	//<20010523a>FormCreateړ

	try{
		Memo1->SetFocus();
	}
	catch(...)
	{
	}
}
//---------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{
	int RetValue = Application -> MessageBox("I܂H",
      "midcompImF",MB_ICONQUESTION | MB_YESNO);

	if(RetValue == IDYES)
    {
		Form1 -> Close();    // I
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton1Click(TObject *Sender)
{
	int ssize;   //<20020212>

	ssize = Memo1->Text.Length();

	if(OpenDialog1->Execute() == true)
	{   //t@Cw肳ꂽƂs

        //<20010125a>
        if(f_tmpcreate==true)
        {
            Form2->Timer1->Enabled=false;
			MediaPlayer1->Close();
			TmpClose();
        }

	    if(f_saveend == false && ssize > 0)
	    {
    		int RetValue = Application -> MessageBox("\[XύXĂ܂"
        	    "\nۑ܂H",
        	  "mF",MB_ICONQUESTION | MB_YESNOCANCEL);

    		if(RetValue == IDYES)
        	{
        	    Save1Click(this);
    		}
        	else if(RetValue == IDCANCEL)
        	{
        	    return;
        	}
	    }
//        Close1Click(this);


//        Memo1->Lines->LoadFromFile(OpenDialog1->FileName.c_str());
//        RichEdit1->Lines->LoadFromFile(OpenDialog1->FileName.c_str());
        //filẽI[vɎsꍇ̔ v0.00.05c <20010828p>
        bool f_fopen = true;   //s(true=,false=s)
        try
        {
			Memo1->Lines->LoadFromFile(OpenDialog1->FileName.c_str());
		}
        catch(...)
        {
            Application->MessageBox("OPENł܂",NULL,MB_ICONSTOP);
            f_fopen = false;  //s
        }

        //I[vłꍇ
        if(f_fopen == true)
        {
            OpenFileAfter();  //fileopenɍs̊֐
        }
        else //łȂƂ
        {
            NotOpenFileAfter();  //fileopenłȂɍs̊֐
        }
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::OutPutLinePos()
{
//    int y_top = RichEdit1->Perform(EM_GETFIRSTVISIBLELINE,0,0);
//    int y_top = Memo1->Perform(EM_GETFIRSTVISIBLELINE,0,0);

	// <20020212p> win2000 ---------------
	int y_top;

	y_top = Memo1->Perform(EM_GETFIRSTVISIBLELINE,0,0);
	// -----------------------------------

//    PaintBox1->Canvas->Font= RichEdit1->Font;

	// <20020212p> Win2000 ----------
	//PaintBox1->Canvas->Font= Memo1->Font;
	//-------------------------------

    //PaintBox1->Canvas->Font->Color=clHighlightText;

//    int setY = -(PaintBox1->Canvas->Font->Height);

    static char d2a_work[] = "xxxxx\0";

    for(int i=0;i<32000;i++)
    {
//        if( (setY*(i+1)) > (RichEdit1->Height-3)) break;

		// <20020212p> win2000 -------------
//		if( (setY*(i+1)) > (Memo1->Height-3)) break;
		// ---------------------------------

        Dec2Asc16(d2a_work,(i+y_top+1));

//        PaintBox1->Canvas->TextOut(10,setY*i+2,d2a_work);
    }

	// <20020212p> win2000
	int ssize;
	ssize = Memo1->Text.Length();

    StatusBar1->Panels->Items[3]->Text = IntToStr(ssize)+" Byte";
}
//====================
void __fastcall TForm1::OutPutCursorPos()
{
//    int y = RichEdit1->Perform(EM_LINEFROMCHAR,RichEdit1->SelStart,0);
//    int x = RichEdit1->SelStart-RichEdit1->Perform(EM_LINEINDEX,-1,0);

	// <20020212p> win2000 ----
	int x,y;

	y = Memo1->Perform(EM_LINEFROMCHAR,Memo1->SelStart,0);
	x = Memo1->SelStart-Memo1->Perform(EM_LINEINDEX,-1,0);
    //--------------------------

    StatusBar1->Panels->Items[0]->Text=IntToStr(y+1)+" s";

    if(x >= 0)  //<20010201p>͈͎w莞}CiX̒lł̂}
    {
        StatusBar1->Panels->Items[1]->Text=IntToStr(x+1)+" ";
    }

    OutPutLinePos();  //<20010305p>
}
//---------------------------------------------------------------------------
void __fastcall TForm1::N4Click(TObject *Sender)
{
    //Ô<20010123a>
    Form2->Timer1->Enabled=false;  //<20010123p>
    MediaPlayer1->Close();
    TmpClose();  //<20010124p>

    //<20010208p>㏑ۑ--
    if(SpeedButton6->Down==true)
    {
        SpeedButton3->Click();
    }

    //-------------------------------

//    RdFilePtr = 0;  // rd1lineG~[Vp
    RdFileLineCnt=0;  //rd1lineG~[Vp

    f_remskip = false; //<20010126a>RgJnƏȈ
    int ret_val;

    Memo2->Text=""; /* crear text */

    ret_val = midmain();      // standard midi file create

    // <20011231p> v0.00.09 SMF쐬ERR֒mP
    if(ret_val == 0){ f_errcreate = false; }
        else {  f_errcreate = true; }

    unsigned long c=0;  // work

    for(int i=0;i<MAX_CH;i++)
    {
        c=c | chxcnt[i];
    }
    /* mid play */
    if( c != 0 && ret_val==0 && f_smfcreate == false)
    {
		MediaPlayer1->Close();
//		MediaPlayer1->DeviceType=dtSequencer;
		MediaPlayer1->FileName = midfname;
//		MediaPlayer1->Display=Form1;
//		MediaPlayer1->FileName = "r:\\aaaa.mid";
		MediaPlayer1->Open();
        MediaPlayer1->TimeFormat = tfMilliseconds;  //<20010204p>
        MediaPlayer1->Rewind();
        MediaPlayer1->Play();

		Form2->TrackBar1->Max= MediaPlayer1->TrackLength[1];
		Form2->TrackBar1->PageSize= MediaPlayer1->TrackLength[1]/20;
		Form2->TrackBar1->Frequency=MediaPlayer1->TrackLength[1]/10;
		Form2->Timer1->Enabled=true; // timer start

		Form2->Show();
//        MediaPlayer1->Close();
    }
    else if(f_smfcreate == false && ret_val==0)
    {
//        ShowMessage("tf[^܂");
		//rev<20010318a>
        Application->MessageBox("tf[^܂",NULL,MB_ICONSTOP);
        //MessageBox(Handle,"tf[^܂",NULL,MB_ICONSTOP);
        SpeedButton2->Enabled=true;
        N4->Enabled=true;
    }

    if(ret_val!=0)
    {
        Form2->Timer1->Enabled=false; //<20010123p>
        SpeedButton2->Enabled=true;
        N4->Enabled=true;
    }

}
//---------------------------------------------------------------------------
void __fastcall TForm1::TmpClose()
{
    if(f_smfcreate == false && f_tmpcreate == true)
    {
        if(remove(midfname)==0)
        {
            f_tmpcreate = false; /* removed */
        }
        else
        {
            Application->MessageBox("tmp file remove error!!",
                    "",MB_ICONSTOP);
        }
    }
}
//--------------------
void __fastcall TForm1::SpeedButton2Click(TObject *Sender)
{
    N4Click(this);
}
//---------------------------------------------------------------------------
//=================================================================
//=================================================================
//====== MIDI COMPILER ============================================
//##########################

/********************************************************/
/*  standard midi format data compiler for DOS v0.00.02 */
/*  Copyright(C)2001 wnc develop  All rights reserved.  */
/*  created by t.w.                                     */
/********************************************************/
/* 2000.12.29  32bit version(Borland C++Builder3 Pro) */
/* 2001. 1. 1  32bit version(rev) */
/* 2001. 1. 2  32bit version(complite) */
/* 2001. 1. 3  32bit & 16bit(LSI-C 86 freesoft) complite  */
/* 2001. 1.14p 16bit(Turbo C 2.01(english) freesoft) */
/*             v0.00.01 volume support and Bug delete */
/* 2001. 1.15a 16bit version power up(fmdsize max:65000)*/
/* 2001. 1.16p read 1 line Bug delete */
/* 2001. 1.17p direct midi output */

/* === v0.00.01ȍ~compile̒ === */
/* compileƂ ->  tcc -ml <fmcomp??> ōs!! */
/* =================================== */


/*------------------------------*/



					/*    0   1t  1   2t  2   4t  4 */
int t_nagasa[LEN_MAX] = {255,192,128, 96, 64, 48, FMO4,  /*0123456*/
						  24, 16, 12,  8,  6,  4,      /*789abc*/
						   3,  2,  1 };		   /*def */
					/*    8t  8  16t 16  32t 32 */
			/*   64t 64  128 */

/* <20010115p> fm compiler  */
/*int t_volume[MAX_VOLUME+1] = { 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};*/

/* <20010115p> midi compiler   0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 */
int t_volume[MAX_VOLUME+1] = { 0,7,15,23,31,39,47,55,63,71,79,87,95,103,111,119,127};


FILE *rd_hand,*wr_hand;

static unsigned char rdwork[LINEMAX+1];

unsigned char *rdworkptr;
int chval;
unsigned char gakki;

int __fastcall TForm1::midmain()
{
    int rdcnt;
    int execd;
    int chopen;
    int ext_err=0;    /*G[ԍ*/

    ch_stack=0; //<20010303p> (chԍ~X̃oO)

    int f_lineloop=1; /*1̎loop,0==[vAEg*/
	int i;  /* for work */

	int fbin_hand;


	chval = 0;
//    c1= argv[1]; /*\[X*/

	/* e`l <20010114p> */
	/*  rev <20010830p> */
	for(i=0;i<MAX_CH;i++)
	{
		okutabu_ch[i] = 4;   /* IN^[u <20010114p> */
		length_ch[i]  = L_4; /*  <20010114p> */
		volume_ch[i]  = 10;  /* default <20010115p> */
		chxcnt[i]     = 0;   /* JE^ <20010120p> */
		chxlen[i]     = 0;   /* Si[p<20010127p> */
//        pan_ch[i]     = PAN_DEF; /* panpot default<20010830p> */
		if(f_q_def7 == false)
		{	q_ch[i]   = Q_DEF;} /* q  <20010321p> */
		else{q_ch[i]  = Q_DEF-1;} /* q defalut(Q7:88VA݊) <20010322a> */
	}

	rd_linecount = 0; /*ǂݍ݃JE^*/

	f_storetmp = 0; /* e|xނ rev<20010321p> */

	f_copyr_sw = false; /*쌠\͖Ƃď <20011231p> v0.00.09 */
	copyr_len  = 0;     /* 쌠͖Ƃď<20011231p>v0.00.09*/

	f_sname_sw = false; /*V[PX͖Ƃď <20020114p> v0.00.10*/
	sname_len  = 0;     /* V[PX͖Ƃď<20020114p>v0.00.10 */

/*----------------------------------------*/
/*sĂ\[Xfmdp̖O쐻*/
//    printf("midiname : %s\n",fmdname);
/*=-------------------------------------*/
	/*ȍ~  exit֐ŔoĂ͂ȂȂ*/
	/*exit֐gpꍇ͊mۂ邱*/


	/* echpm <20010120p> ====*/
	int mcwrk;
	bool f_mcwrkerr=false; //擾Ɏs true
	for(mcwrk=0;mcwrk< MAX_CH;mcwrk++)
	{
		if ((chxmem[mcwrk] =(unsigned char*) malloc(CH_MEMMAX+1)) ==NULL)
		{
			f_mcwrkerr=true; // out of memory
			break;  // for break out
		}
	}
	/*  */
	if(f_mcwrkerr==true)
	{
		for(int i=0;i< (mcwrk+1);i++)
		{   free(chxmem[i]);}
		Application->MessageBox("out of memory",NULL,MB_ICONSTOP);
		return 1;  /* out of memory return */
	}
	/*==================================*/

	while(f_lineloop)
	{
		rdcnt = rd1line();
		rdworkptr=rdwork;  /* reset */
		while(1)
		{
			if(rdcnt <= 0){f_lineloop=0;break;}

			execd = chkexec();

			/* debug */
			/* printf("execd:%d\n",execd); */

			/* ߃R[hɂ镪 */
            switch(execd)
            {
                case 0: break;  //Rgs
                case 1: chopen=chval;break;
                case 2: open_ch(chopen);break;
                case 3: ext_err = cdecnv();break;
                case 4: close_ch();break;
                case 5: break;  //<20010126a>  RgJn
                case 6: break;  //<20010126a>  RgI
                case 7: ext_err = option_set();break;
                case 8: ext_err = copyr_set();break; /* <20011231a> */
                case 9: ext_err = sname_set();break; /* <20020114p> */
                case -1: ext_err = 1;break;
                default: Memo2->Lines->Add("op code err");ext_err = 1;break;
            }
            if(ext_err != 0)
            {
				//G[NƂ̕\
//                Memo2->Lines->Add(" -> line ("
//                    +IntToStr(rd_linecount)+"):"+(char*)rdwork);
				char d2awork[]="XXXXX\0"; //work
                Dec2Asc16(d2awork,rd_linecount);

				AnsiString As1,As2;
                for(int i=0;i<(rdworkptr-rdwork);i++)
                	{	As1+=" ";}
                As2 = d2awork;
				Memo2->Lines->Add("ERR -> line ["
                	+As2+"]:"+(char*)rdwork);
				Memo2->Lines->Add("                    "+
                	As1+"?");
                out_exterr(ext_err);

                f_lineloop = 0;  /*loop stop*/
                break;
            }

            if(execd== 0)break;
        }
/*        if(rdcnt <= 0)break; */
    }
    closesource1();

    if(ext_err != 0)
    {
        //Application->MessageBox("compile stopped!",NULL,MB_ICONSTOP);
    }
    else
    {
		if(f_nomidiout == false)  //truêƂmidio͂Ȃ
		{
			fbin_hand = openfmbin();

			if(fbin_hand < 0)
			{
				Application->MessageBox(
					"݃t@CG[",NULL,MB_ICONSTOP);
				ext_err = 1;
			}
			else
			{
				ext_err = wrtfmbin();
				if(ext_err == 0)
				{
					ext_err = closefmbin();
				}
				else             //<20010127p>
				{
					out_exterr(ext_err); //<20010127p>
					closefmbin();  //close
					ext_err = 1;  //<20010127p>
				}
			}
		}

	}

	//v1.01.00 <20170919p>
	if(f_nomidiout == true)  //truêƂfmcompf[^o͂̂
	{
		//Track LengthvZē(SMFo͎͂łɓĂ̂ŕsv)
		//fmcompf[^ô͎0ɂȂĂ̂ōČvZ
		for(int i=0;i< MAX_CH;i++)
		{
			if(chxcnt[i]>0)
			{
				int chxcntwork;
				chxcntwork = chxcnt[i];  //ch̊i[oCg擾

				unsigned char *p;
				p = chxmem[i];       //Y`l̃f[^i[ꏊ擾

				int chxlenwork;
				chxlenwork=0;

				for(int j=0;j< chxcntwork;j+=2)
				{
					// 096܂ł͉, 255͏IR[h
					// +0ɉE@\ԍA+1ɒEl
					if( p[j] <= 96 ) { chxlenwork += p[(j+1)]; }
					if( p[j] == 255 ) { break;}   //break
				}
				chxlen[i]=chxlenwork; //i[
			}
		}
	}
	//-------------

	if(ext_err == 0)
	{
		AnsiString as1;
		int lenwork;
		for(int i=0;i< MAX_CH;i++)
		{
				if(chxcnt[i]>0)
				{
					as1 = " -> ch" + IntToStr(i+1)+" size("
						+IntToStr(chxcnt[i])+" byte)  ";
					if(f_nomidiout == true)  //truefmcompf[^o͂̂
					{
						as1 += "fmc Length";
						lenwork = chxlen[i];
					}
					else
					{
						//SMFo͎
						as1 += "Track Tick";
						// *15͎l(fmc 32)15{(32*15 = 480)
						lenwork = chxlen[i]*15;
					}
					as1 += " ("+IntToStr( lenwork )+")";
					Memo2->Lines->Add(as1);
				}
		}
		Memo2->Lines->Add(" ** RpCI **");
	}
	else
	{
		Application->MessageBox("compile stopped!",NULL,MB_ICONSTOP);
	}

	//fmcompf[^쐬Ƃ----------------
	//v1.01.00 <20170912a>
#define FMCENDSIZE 2
	if(f_nomidiout == true)    //true̎midio͂sȂ
	{
		unsigned char endcode[FMCENDSIZE];

		for(int i=0;i<FMCENDSIZE;i++)
		{
			endcode[i]=0xff;
		}

#define FMCHEDSIZ 16
		//+e+fɂ̓f[^Jnʒu(ʏ0x0010Ƃ)
		unsigned char fmcstr[FMCHEDSIZ+1] = "FMP000FMC001\x20\0\x10\0";


#define FMCCHDATOFSSIZ 32
		unsigned char fmcchdatofs[FMCCHDATOFSSIZ];
		for(int i=0;i<FMCCHDATOFSSIZ;i++)
		{
			fmcchdatofs[i]='\0';  // 0clear
		}

		//̃bZ[Wo͂Ƃ͊mۃTCYzO̎
		#if ((MAX_CH*2) > FMCCHDATOFSSIZ)
			Application->MessageBoxA("MAX_CH*2 > FMCCHDATOFSSIZ",NULL,MB_OK);
			return 1;  //err stopƂ
		#endif

		unsigned short chtotallen;
		chtotallen = 0;   //ݐς̃`lLENƂ
		chtotallen += 32;   //`lofs32oCg邽ߐi߂

		for(int i=0;i< MAX_CH; i++)
		{
			//fmcchdatofs
			unsigned short chlen;
			chlen = (unsigned short)chxcnt[i];

			unsigned short *p_s;

			if(chlen >= 1)
			{
				//1ȏ̎(ofs+32Ƃ)
				p_s = (unsigned short*)&fmcchdatofs[(i*2)];
				p_s[0] = chtotallen;  //ch*2oCgڂɏ

				//̃`lJnʒu
				chtotallen += (chlen+2);  //+20ff 0ff̏IR[h
			}
		}

		//wb_Ɗechf[^̃ItZbg v1.01.00
		fmdat->Write(fmcstr,FMCHEDSIZ);
		fmdat->Write(fmcchdatofs,FMCCHDATOFSSIZ);

		for(int i=0;i< MAX_CH;i++)
		{
			if(chxcnt[i] > 0)
			{
				unsigned char *p;
				p = chxmem[i];
				fmdat->Write( p, chxcnt[i]);
				fmdat->Write(endcode , FMCENDSIZE);  //end1
			}
		}
	}
	//------------------------------------------

	/*==========================*/
	/* ̉ */
	/*  */
	for(int i=0;i< MAX_CH;i++)
    {   free(chxmem[i]);}

    return ext_err;
}

inline int __fastcall TForm1::opensource1(char *sourcename)
{
	return 0;
}
/*-------------------*/
/*-------------------------------*/
int __fastcall TForm1::rd1line()
{
	char *p;
//	int f_rd;
	int c;

    p= (char*)rdwork;   /*work area addr*/
    *p = 0;   /*Ԃ͂߂(듮h~)*/

	// <20020212p> win2000 -----
	int MaxLine;

	MaxLine = Memo1->Lines->Count; //s߂
	//---------------------------

	AnsiString AsWork1;  //work area

	if(RdFileLineCnt < MaxLine)
	{
		//<20020212p> win2000 --------
		AsWork1=Memo1->Lines->Strings[RdFileLineCnt];
		//----------------------------

		c=strlen(strncpy(p,AsWork1.c_str(),LINEMAX-2));
		p[c]=0x0d;  //sR[hIɓ
		c++;  //sR[hǂݍ񂾈
		p[c]='\0';  //Iendcode <20020114p> v0.00.10

		//Pső啶x<20020114p> v0.00.10
		if(c >= LINEMAX)
		{
			char d2awork[]="XXXXX\0"; //work
			Dec2Asc16(d2awork,rd_linecount+1);
			AnsiString As1;
			As1 = d2awork;
			Memo2->Lines->Add(" [x] line ("+As1+") : "
				"Ps "+IntToStr(LINEMAX)+" Byteȓ");
		}
	}
	else
	{
		c=0;
	}

	// debug
/*    if(c>0)
	{
	AnsiString As2=(char*)rdwork;
	ShowMessage(As2);
	}
*/
	RdFileLineCnt++; //̍sɂ
	rd_linecount++;  //ǂݍݍsinc

	return (c); /*no error*/
}
//---------------------------------------
inline int __fastcall TForm1::closesource1()
{
	return 0;  /*debugclose*/
}

int __fastcall TForm1::openfmbin()
{
	/*printf("openfmbin\n");*/

	if(f_smfcreate == true && f_save == true)
	{

        if ((wr_hand = fopen(bmidfname,"wb"))==NULL)
        {	return -1;}
    }
    else
    {

		char tmpfname[L_tmpnam];
        tmpnam(tmpfname);
        /* temp midi filename create */
      	//AnsiString f1,p1;
        //p1 = Application -> ExeName;

        //<20010124p> temp path=====
        AnsiString f1;
        char tmppath[MAX_PATH+2];
        if(GetTempPath(MAX_PATH,tmppath)<=0)
        {
            Application->MessageBox("Temp Path error"
                ,NULL,MB_ICONSTOP);
            return -1;
        }
        f1=tmppath;
        f1+=tmpfname;
		//add 20130218
    	f1+=".mid";

		//ShowMessage(debugf);
		//==========================
		//f1 = ExtractFilePath(p1)+tmpfname;

        strncpy(midfname,f1.c_str(),MAXPATH-2);

        if ((wr_hand = fopen(midfname,"wb"))==NULL)
        {
            //ShowMessage("tmpfile not create");
			//rev<20010318a>
            Application->MessageBox("TMPfile쐬ł",NULL,MB_ICONSTOP);
            //MessageBox(Handle,"TMPfile쐬ł",NULL,MB_ICONSTOP);
        	return -1;
        }
        else
        {
            f_tmpcreate = true;  /* tmp create */
        }
    }
    return 0;
}

/* =============================================== */
/* midcomp v0.00.02 <20010117p> */
void __fastcall TForm1::MidHedOut(unsigned short midformat,unsigned short trackval,unsigned short onpu4)
{
	unsigned char midwrtwork[16]; /* midi hed work */
	unsigned char *p;
	unsigned short *p_s;
	unsigned char a; /* work */

	p=midwrtwork;
	p[0]='M'; p[1]='T'; p[2]='h'; p[3]='d';
	p[4]=0; p[5]=0; p[6]=0; p[7]=6;

	p_s = (unsigned short*)(p+8); /* format store addr */
	*p_s = midformat;
	a = p[9]; p[9]=p[8]; p[8]=a;  /* gGfBA */

	p_s = (unsigned short*)(p+10); /* gbN̐ */

	//bug v1.01.00 (20170908)
	trackval++;  //R_N^[gbNǉ
	*p_s = trackval;

	a = p[11]; p[11]=p[10]; p[10]=a;  /* gGfBA */

	p_s = (unsigned short*)(p+12); /* l̒ */
	*p_s = onpu4;
	a = p[13]; p[13]=p[12]; p[12]=a;  /* gGfBA */

	/* midi hedt@Cɏo */
	fwrite(midwrtwork,1,14,wr_hand); /* wb_TCY14byteŒ */
}

/* =============================================== */
/* midcomp v0.00.02 <20010116p> */
int __fastcall TForm1::wrtfmbin()
{
	// midi comp32
	int c = 0; /* o͂gbN */

	//<20010127p>
	int ret_val=0; /* G[ԍ */

	for(int i=0;i<MAX_CH;i++)
	{
		if(chxcnt[i] > 0) c++;
	}

	if(c == 0)return 0; /* ret */

	/* SMFɂ͕KKv */
//	MidHedOut(1,(unsigned short)c ,32);   /* MidHedOut(format,track,onpu4) */
	MidHedOut(1,(unsigned short)c ,O4BK);   /* MidHedOut(format,track,onpu4) */
	MidTrackOutConductor();              /* v1.01.00 (20170908a) */

	for(int i=0;i< MAX_CH;i++)
	{
		if(chxcnt[i] > 0)
		{
			/* rev<20010127p> MidTrackOut(炷ch, addr ,count) */
			ret_val=MidTrackOut(i+1,chxmem[i],chxcnt[i]);
		}

		if(ret_val != 0)break;  // rev<20010315p>
	}
//    ShowMessage("ret_val="+IntToStr(ret_val));
	return ret_val;  //<20010127p>
}
/* ============================ */
/* and֐(߂l͉Z钷)<20010127p>*/
int __fastcall TForm1::len_and(unsigned char *ch_addr,long ch_count,int &i)
{
    int ret_len=0;  //߂̒i[p
    int j;  //p

    j=i+2;

    //debug
    //Memo2->Lines->Add("len_and j:"+IntToStr(j));

    while(ch_count>=(j+3))
    {
        if(ch_addr[j]== 251)
        {
            ret_len+=ch_addr[j+3];  // 251,0̎ɂ閽߂̒
            i+=4;  /* Ƃi251,0̎*/
            j+=4;  /* 251,0ô*/

            //debug
            //Memo2->Lines->Add("len_and i:"+IntToStr(i));
        }
        else
        {
            break; /* 251ȊÔƂwhile𔲂o */
		}
	}

	//debug
	//Memo2->Lines->Add("len_and i:"+IntToStr(i));
	//debug
	//Memo2->Lines->Add("ret_len:"+IntToStr(ret_len));
	return ret_len;
}
//----------------------------------------

void __fastcall TForm1::MidTrackOutConductor(void)
{
	//gbN0ԂƂďo
#define MIDWRTWORKSIZ 100
	unsigned char midwrtwork[MIDWRTWORKSIZ];  /* ޑÖꎞstack */
	unsigned char *p;
	unsigned long *p_l; /* work */
	unsigned char a; /* work */

	long midfilepos;  /* t@C|C^̈ʒui[p */
	unsigned long trackcount;  /* track count */

	/* f[^̏ */
	/* ݂̃t@C|C^ʒuL^ */
	midfilepos = ftell(wr_hand);

	/* gbNJn錾 */
	p= midwrtwork;
	p[0]='M'; p[1]='T'; p[2]='r'; p[3]='k'; /* gbNJn錾 */
	p[4]=0xff;p[5]=0xff;p[6]=0xff;p[7]=0xff; /* TCYsmȂ̂ōől */
	p[8]=0; /* gbNTCY̎̂͒P */
	fwrite(midwrtwork,1,9,wr_hand);  /* 9byte write */

	/*f[^output */

	trackcount = 1;  /* ł1byteݍς݂̂ 1 Jn */

	/* <20011231p> v0.00.09  cr@\ ------ */
	/* 쌠\񏑂o */
	if(f_copyr_sw == true) /* 쌠o true=o */
	{
		p = midwrtwork;
		p[0]=0xff;
		p[1]=0x02;
		p[2]=(unsigned char)copyr_len; /* 쌠̒ */
		fwrite(midwrtwork,1,3,wr_hand); /* 3 byte wrt */
		trackcount += 3;  /* size */
		fwrite(copyr_work,1,copyr_len,wr_hand); /* copyr_len byte wrt */
		trackcount += copyr_len; /* wrt size add */
		p[0]=0;
		fwrite(midwrtwork,1,1,wr_hand); /* tick count */
		trackcount += 1;  /* size */
	}

	/* ----------------------------------- */
	/* <20020114p> v0.00.10  sn@\ ------ */
	/* V[PXo */
	if(f_sname_sw == true) /* V[PXo true=o */
	{
		p = midwrtwork;
		p[0]=0xff;
		p[1]=0x03;    /* 03  sname */
		p[2]=(unsigned char)sname_len; /* V[PX̒ */
		fwrite(midwrtwork,1,3,wr_hand); /* 3 byte wrt */
		trackcount += 3;  /* size */
		fwrite(sname_work,1,sname_len,wr_hand); /* sname_len byte wrt */
		trackcount += sname_len; /* wrt size add */
		p[0]=0;
		fwrite(midwrtwork,1,1,wr_hand); /* tick count */
		trackcount += 1;  /* size */
	}
	/* ----------------------------------- */

	// <20170908a> v1.01.00 @\ǉ ====
	// 8/1ɂƂ
	p = midwrtwork;  //ꎞf[^i[GA
	p[0]=0xff;    //
	p[1]=0x58;    //
	p[2]=0x04;    //
	p[3]=0x01;    //1
	p[4]=0x03;    //0x02=4,0x03=8  (8/1)
	p[5]=0x18;    //
	p[6]=0x08;    //
	p[7]=0x81;    //x点鎞(240)
	p[8]=0x70;    //
	fwrite(midwrtwork,1,9,wr_hand);  /* 9 byte wrt */
	trackcount += 9;  /*  end size */
	//=====================================

	//l̃e|Ƃ120
	trackcount += midtmpwrt(TEMPO);

	// <20170908a> v1.01.00 @\ǉ ====
	// 4/4ɂƂ
	p = midwrtwork;  //ꎞf[^i[GA
	p[0]=0xff;    //
	p[1]=0x58;    //
	p[2]=0x04;    //
	p[3]=0x04;    //1
	p[4]=0x02;    //0x02=4,0x03=8  (8/1)
	p[5]=0x18;    //
	p[6]=0x08;    //
	p[7]=0x00;    //x点鎞
	fwrite(midwrtwork,1,8,wr_hand);  /* 9 byte wrt */
	trackcount += 8;  /*  end size */
	//=====================================

	//e`lɏoTEMPÕgbNɏo͂
	//v1.01 <20170923a>
	//oO

	int d_time_work;

	for(int i=0;i< MAX_CH;i++)
	{
		//e`lJn
		d_time_work = 0;   //f^^CƂ(e|߂oĂƂ̊)

		if(chxcnt[i] > 0)
		{
			p = chxmem[i];
			for(int j=0;j < (signed)chxcnt[i];j+=2)
			{
				if(p[j] <= 96)  //fB̎擾
            	{
					int n;
					n = (int)p[(j+1)];
					d_time_work += (O4BK / FMO4) * n;  // (480 / 32) *n
				}

				if(p[j] == 252)  //tempo 252
				{
					//܂łd_time_worko͂Ă(o͂̓Rg)
					unsigned char *p2;
					p2 = midwrtwork;  //ꎞf[^i[GA
					p2[0]=0xff;    //
					p2[1]=0x01;    //text
					p2[2]=0x01;    // 1 
					p2[3]='_';     // _
					p2[4]=0x0;    //x点鎞 ɓƂ
					p2[5]=0x0;    //
					unsigned long c;
					c = midlencnv( &p2[4], (MIDWRTWORKSIZ-4) , d_time_work);
					c += 4;  //ł4oCĝŉZ
					trackcount += c;  /*  end size */
					fwrite(midwrtwork,1, c ,wr_hand);  /* c byte wrt */
					d_time_work = 0; //񂾂̂ŏ

					unsigned char a;
					a = p[(j+1)];
					trackcount += midtmpwrt(a);
				}
			}
		}
	}
	//------------------------
	//ׂĂ̏o͂͂܂łŏIĂ
	//̉ŏIƃTCYނ
   /* Ïo */

	p = midwrtwork;  //ꎞf[^i[GA
	p[0]=0xff;p[1]=0x2f;p[2]=0; /* end track */
	fwrite(midwrtwork,1,3,wr_hand);  /* 3 byte wrt */
	trackcount += 3;  /*  end size */

	/* t@C|C^obNAbvƂɖ߂ */
	fseek(wr_hand,midfilepos,SEEK_SET);
	/* 񂾃gbNMTrk'M'܂Ŗ߂ */

	/* Tracksize܂ŃV[N */
	fseek(wr_hand,4L,SEEK_CUR);

	p_l = (unsigned long*)midwrtwork;
	*p_l = trackcount;  /* trackcounti[ */

	a = p[3]; p[3]=p[0]; p[0]=a;  /* 3 xchg 0 */
	a = p[1]; p[1]=p[2]; p[2]=a;  /* 2 xchg 1 */
	fwrite(midwrtwork,1,4,wr_hand);  /* 4 byte wrt */

	fseek(wr_hand,0L,SEEK_END); /* file end ܂ňړ */
   /* ===================================== */
}


/* =========================================== */
/* midcomp v0.00.02 <20010116p> */
int __fastcall TForm1::MidTrackOut(int ch_run,unsigned char *ch_addr,long ch_count)
{
	int i;  /* for next (rev<20010127p>)*/
//	unsigned char cde_len;  /* cde length */
	unsigned int cde_len;  /* cde length rev<20010322p> */
	unsigned char cde;  /* onkai */
	int wrt_volume;  /* volume default <20010115p> */
	unsigned char midwrtwork[100];  /* ޑÖꎞstack */
	unsigned char *p;
	unsigned long *p_l; /* work */
	unsigned char a;  /* work */

	long midfilepos;  /* t@C|C^̈ʒui[p */
	unsigned long trackcount;  /* track count */
	int f_startcde = 0; /* 0x9?R[hgptO 0==,0<>) */

	//̓oOȂ̂ŒKv(<20010321p>)
//	static int f_storetmp = 0; /* e|xނ */

	//ch_run_exiOϐjɌݏݒch <20010321p>
	ch_run_ex = ch_run;   //( 1`9܂ł̐l )


	/* f[^̏ */
	/* ݂̃t@C|C^ʒuL^ */
	midfilepos = ftell(wr_hand);

	/* gbNJn錾 */
	p= midwrtwork;
	p[0]='M'; p[1]='T'; p[2]='r'; p[3]='k'; /* gbNJn錾 */
	p[4]=0xff;p[5]=0xff;p[6]=0xff;p[7]=0xff; /* TCYsmȂ̂ōől */
	p[8]=0; /* gbNTCY̎̂͒P */
	fwrite(midwrtwork,1,9,wr_hand);  /* 9byte write */

	/*f[^output */

	trackcount = 1;  /* ł1byteݍς݂̂ 1 Jn */
	wrt_volume = 10; /* <20010115p> default */

	/* VXeplo (PTrack̂) */
	if(f_storetmp == 0)
	{
		// <20010309p> v0.00.04a @\ǉ ====
		//GM system on
		p = midwrtwork;  //ꎞf[^i[GA
		p[0]=0xf0;    //GNXN[VuEXe[^X
		p[1]=0x05;    //byte(TCY)
		p[2]=0x7e;    //IDio[(ް٥رѥү)
		p[3]=0x7f;    //foCXID(Broadcast)
		p[4]=0x09;    //TuID#1(General MIDi Message)
		p[5]=0x01;    //TuID#2(General MIDI On)
		p[6]=0xf7;    //EOX(ޥޥٰ)
//        p[7]=0x05;    //x点鎞(50msȏ)
//		p[7]=0x00;    //x点鎞(50msȏ v1.01 tick 0.5/480tick)
		p[7]=0x81;    //x点鎞(144)
		p[8]=0x10;    //
		fwrite(midwrtwork,1,9,wr_hand);  /* 9 byte wrt */
		trackcount += 9;  /*  end size */
	//=====================================
		f_storetmp = 1;
	}
	else
	{
		//2trackȍ~̓RgĎԒ
		p = midwrtwork;  //ꎞf[^i[GA
		p[0]=0xff;    //
		p[1]=0x01;    //text
		p[2]=0x01;    // 1 
		p[3]='_';     // _
		p[4]=0x81;    //x点鎞(144)
		p[5]=0x10;    //
		fwrite(midwrtwork,1,6,wr_hand);  /* 6 byte wrt */
		trackcount += 6;  /*  end size */

	}

	// <20010309p> v0.00.04a @\ǉ========
	p = midwrtwork;  //ꎞf[^i[GA
//		p[0]=0xb0;    //I[TEhIt
	unsigned char bch;  //v1.01.00 (20170906)oO
	bch = (unsigned char)ch_run; //ݒ̃`l
	bch = bch & 0x0f;  //0}XN
	bch = bch | 0xb0;  //0xb0 or
	p[0]=bch;    //I[TEhIt
	p[1]=0x78;
	p[2]=0x00;
//		p[3]=0x05;    //x点鎞(50msȏ)
//	p[3]=0x32;    //x点鎞(50msȏ v1.01 tick 0.5/480 tick)

	p[3]=0x60;    //x点鎞 (96)
	fwrite(midwrtwork,1,4,wr_hand);  /* 4 byte wrt */
	trackcount += 4;  /*  end size */
	//=======================================

	/* yƂăsAm */
	if(ch_run != 9)
	{
    	//Y`lȊO̓sAmw
		trackcount += midmelwrt((unsigned char)ch_run,0); /* (ch,len) */
	}

	/*Ez̎Panpot`lƂɓ*/
	/*v0.00.07 <20010906p>--*/
	if(ch_run >= 2 && ch_run <= 7 && S1->Checked==true)
	{
		int autopanpot = PAN_DEF; /*panpot */
		switch(ch_run)
		{
			case 2: autopanpot = MIN_PAN;break;
			case 3: autopanpot = MAX_PAN;break;
			case 4: autopanpot = PAN_DEF/3;break;
			case 5: autopanpot = PAN_DEF/3+PAN_DEF;break;
			case 6: autopanpot = PAN_DEF/3*2; break;
			case 7: autopanpot = PAN_DEF/3*2+PAN_DEF;break;
		}
		trackcount += midpanwrt((unsigned char)ch_run,autopanpot);
	}
	/*---------------------*/


	for(i=0;i<ch_count;i+=2)
	{
		cde = ch_addr[i];
		cde_len = ch_addr[i+1];
		if(cde <= 96 && cde != 0)
		{
			if(f_startcde == 0) /* ߖgp */
			{
				a = (unsigned char)(ch_run & 0x0f);
				a = (unsigned char)a | (unsigned char)0x90;  /* mask */
				p[0] = a; /* store */
				fwrite(midwrtwork,1,1,wr_hand); /* 1 byte write */
				trackcount++;  /* 1byte */
				f_startcde = 1;  /* gpς݂ɕύX */
			}
//			cde_len+=(unsigned char)len_and(ch_addr,ch_count,i); /* <20010127p>and֐*/
			cde_len+=(unsigned int)len_and(ch_addr,ch_count,i); /* <20010127p>and֐*/
			chxlen[ch_run-1]+=cde_len;  /* <20010127p>Si[ */
			//debug
			#if 0
			  Memo2->Lines->Add("cde_len:"+IntToStr(cde_len));
			#endif
			trackcount += midcdewrt(cde,wrt_volume,cde_len);
		}
		else if(cde == 255)
		{
			break;
		}
		else if(cde == 254) /* melody change */
        {
			trackcount += midmelwrt((unsigned char)ch_run,cde_len); /* (ch,len) */
			f_startcde = 0;  /* gpɕύX */
		}
		else if(cde == 253) /* volume <20010115p> */
		{
			wrt_volume = cde_len;  /* volume set <20010115p> */
			if(wrt_volume > MAX_VOLUME) wrt_volume = MAX_VOLUME;
		}
		else if(cde == 252) /* tempo <20010115p> */
		{
			//debug
			#if 0
        	Memo2->Lines->Add("tempo:"+IntToStr(cde_len));
			/*printf("tempo:%d\n",cde_len);*/
			#endif
			//SMFo͎ł͖(ŏ̃gbNŏo͂悤)
			#if 0
			trackcount += midtmpwrt(cde_len);
			#endif
		}
		else if(cde == 251) /* and <20010127p> */
        {
            //debug
			Memo2->Lines->Add("[G[] & LPƂő(ch"+
                IntToStr(ch_run)+")");
            return 11;  /* error (ʊ֐邽߂ŏo͂Ȃ)*/
		}
		else if(cde == 250) /* q value<20010321p>v0.00.05 */
		{
			//zɂĂ̂͏듮h~邽
			q_ch[ch_run-1]=cde_len;  /* q value backup v0.00.05 */
//			trackcount += midtmpwrt(cde_len);
		}
		else if(cde == 249) /* panpot<20010830p>v0.00.06 */
		{
			trackcount += midpanwrt((unsigned char)ch_run,cde_len); /*(ch,len)*/
			f_startcde = 0;  /* gpɕύX(ȂƑɉł) */
		}
		else if(cde == 0) /* x */
		{
			if(f_startcde == 0) /* ߖgp */
			{
				a = (unsigned char)(ch_run & 0x0f);
				a = (unsigned char)a | (unsigned char)0x90;  /* mask */
				p[0] = a; /* store */
				fwrite(midwrtwork,1,1,wr_hand); /* 1 byte write */
				trackcount++;  /* 1byte */
				f_startcde = 1;  /* gpς݂ɕύX */
			}
            chxlen[ch_run-1]+=cde_len;  /* <20010127p>Si[ */
			trackcount += midcdewrt( 0 , 0 , cde_len);  /*  ԍ 0  0 */
		}
	}
   /*܂*/

   /* Ïo */

	p[0]=0xff;p[1]=0x2f;p[2]=0; /* end track */
	fwrite(midwrtwork,1,3,wr_hand);  /* 3 byte wrt */
	trackcount += 3;  /*  end size */

	/* t@C|C^obNAbvƂɖ߂ */
	fseek(wr_hand,midfilepos,SEEK_SET);
	/* 񂾃gbNMTrk'M'܂Ŗ߂ */

	/* Tracksize܂ŃV[N */
	fseek(wr_hand,4L,SEEK_CUR);

	p_l = (unsigned long*)midwrtwork;
	*p_l = trackcount;  /* trackcounti[ */

	a = p[3]; p[3]=p[0]; p[0]=a;  /* 3 xchg 0 */
	a = p[1]; p[1]=p[2]; p[2]=a;  /* 2 xchg 1 */
	fwrite(midwrtwork,1,4,wr_hand);  /* 4 byte wrt */

	fseek(wr_hand,0L,SEEK_END); /* file end ܂ňړ */
   /* ===================================== */
	return 0;
}
/* ============================================== */
//
unsigned long __fastcall TForm1::midlencnv(unsigned char *w_p,int wpmax,int m_len)
{
	unsigned int a8work;  //<20010127p>
	unsigned int b4,b3,b2,b1;
	unsigned long c;
	c=0;

	if(wpmax <= 4) { return c;}  /* 4byteȏw_pƂ */
//	b4=0;b3=0;b2=0;b1=0;

	a8work = (unsigned int)m_len;
	//debug
	#if 0
	Memo2->Lines->Add(IntToStr(a8work));
	#endif

	b2 = (a8work >> 7);
	b3 = (a8work >> 14);
	b4 = (a8work >> 21);

	b1 = a8work & 0x7f;
	b2 = b2 & 0x7f;
	b3 = b3 & 0x7f;
	b4 = b4 & 0x7f;

	if(b4 != 0) { b4 |= 0x80; w_p[c]=(unsigned char)b4;c++;}
	if(b3 != 0) { b3 |= 0x80; w_p[c]=(unsigned char)b3;c++;}
	if(b2 != 0) { b2 |= 0x80; w_p[c]=(unsigned char)b2;c++;}
	w_p[c]=(unsigned char)b1;c++;

	return c;
}

//--------------------------
/* h~ */
unsigned long __fastcall TForm1::midcdewrt(unsigned char m_key,int m_vol,int m_len)
{
#define W_PMAX 10
	unsigned char w_p[W_PMAX]; /* work area */
	unsigned long c=0; /* work */

	unsigned char q_adjust;  /* <20010321p> v0.00.05 (Cp)*/
	unsigned char q_len;     /* <20010321p> v0.00.05 (炷) */

	/* m_key+MID_ADJUSTƂĂ̂fmcompƂ̂˂ */
	w_p[c] = (unsigned char)((unsigned char)m_key+MID_ADJUST); c++;
	w_p[c] = (unsigned char)t_volume[m_vol]; c++;

	//m_len͎l32ƂČvZĂ̂
	//l480ƂȂ悤ɌvZ v1.01.00 (2017/09/06)
	m_len = m_len * (O4BK / 32);

	//debug
	#if 0
		Memo2->Lines->Add("m_len:"+IntToStr(m_len));
	#endif



	//rev<20010127p>
//	if(m_len >= 128 && m_len <= 16384-1)
	if(m_len >= 128)
	{
		// midlencnv(WORKADDR,WORKMAXSIZE,l) ߂l͏݃oCg
		c += midlencnv(&w_p[c],(W_PMAX-c),m_len);
/*
		int a8work;  //<20010127p>
		a8work = m_len;
		a8work = a8work >> 7; // 7bit R<20010127p>
		a8work = a8work & 0x07f;  //7bit mask<20010127p>
		a8work = a8work | 0x80;   //bit7 on<20010127p>
		w_p[c] = (unsigned char)a8work; c++; //rev<20010127p>
		w_p[c] = (unsigned char)(m_len & 0x7f); c++; //rev<20010322p>
*/
		//debug<20010127p>
		//Memo2->Lines->Add("m_len(128<=x):"+IntToStr(m_len)+",a8work:"+IntToHex(a8work,4));
		//Memo2->Lines->Add("m_len(128<=x):"+IntToStr(m_len)+",(0x7f):"+IntToHex(m_len&0x7f,4));
		w_p[c] =(unsigned char)(m_key+MID_ADJUST); c++;
		w_p[c] = 0; c++;  // volume 0 (Ď̉ɑΉ)
		w_p[c] = 0; c++;  // len 0 (̖߂܂ł̎) original

	}
	else
	{
//		w_p[c] = (unsigned char)m_len; c++;  // original

		//xȂ邪Č߂邽߂ɓ
		float work_m_len;
		work_m_len = (m_len/8.0) * ((q_ch[ch_run_ex-1])+1); //rev
		q_len = (unsigned char)work_m_len; //convert

		/* A듮삷̂ */
		if(q_len==0 && m_len >= 1) /* rev<20010830p> v0.00.06 */
		{
			q_len = 1;  //<20010321p>炷͍ŒP
		}

		w_p[c] = (unsigned char)q_len; c++;  //rev<20010321p> v0.00.05

		w_p[c] =(unsigned char)(m_key+MID_ADJUST); c++;
		w_p[c] = 0; c++;  /* volume 0 (Ď̉ɑΉ)*/

		q_adjust =(unsigned char)(m_len-q_len);  /* C <20010321p> */

		w_p[c] = q_adjust; c++;  /* (̖߂܂ł̎) rev<20010321p>*/

	}

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);  /* write count return */
}
/* ============================================== */
/* yԍύX */
unsigned long __fastcall TForm1::midmelwrt(unsigned char m_ch,int m_len)
{
	unsigned char w_p[10]; /* work area */
	unsigned long c;  /* write count */
	unsigned char a; /* work */

	a =(unsigned char)(m_ch & 0x0f); /* mask */
	a =(unsigned char)( a | 0xc0);   /* or mask */

    if(m_len > MAXGAKKI)
    {
        m_len = 0; /* over flow reset */
    }

	c=0; /* reset */
	w_p[c] = a;  c++; /* melody chenge */
	w_p[c] = (unsigned char)m_len; c++;  /* melody no. */
	w_p[c] = 0; c++; /* tick */

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);
}
/* ============================================== */
/* tempo */
unsigned long __fastcall TForm1::midtmpwrt(int m_len)
{
	unsigned char w_p[10]; /* work area */
	unsigned long c;  /* write count */
	unsigned char a; /* work */
	double b; /* work */
	unsigned long msec4; /* work */
	unsigned long *p_l; /* work */
	unsigned char *p;

	b = 60.0 / m_len * 1000000; /* micro sec */
	msec4 = (unsigned long)b; /* convert */

	c=0; /* reset */
	w_p[c] = 0xff; c++;
	w_p[c] = 0x51; c++;
	w_p[c] = 0x03; c++;

	p_l = (unsigned long*)(w_p+c);
	p = (unsigned char*)p_l;

	*p_l = msec4;  /* tempo store */

	a = p[3]; p[3]=p[0]; p[0]=a;  /* 3 xchg 0 */
	a = p[1]; p[1]=p[2]; p[2]=a;  /* 2 xchg 1 */

	p[0] = p[1];
	p[1] = p[2];
	p[2] = p[3];  /* 24 bit data */

	c += 3;

	w_p[c] = 0;  /* PZbg̏I */
	c++;

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);
}
/* ============================================== */
/* Panpot(̏o͕)<20010830p>v0.00.06 */
/* ============================================== */
unsigned long __fastcall TForm1::midpanwrt(unsigned char m_ch,int m_len)
{
	unsigned char w_p[10]; /* work area */
	unsigned long c;  /* write count */
	unsigned char a; /* work */

	a =(unsigned char)(m_ch & 0x0f); /* mask */
	a =(unsigned char)( a | 0xb0);   /* or mask() */

    if(m_len > MAX_PAN)
    {
        m_len = PAN_DEF; /* over flow reset */
    }

	c=0; /* reset */
	w_p[c] = a;  c++; /* panpot */
    w_p[c] = 0x0a;c++; /* panpot */
	w_p[c] = (unsigned char)m_len; c++;  /* panpot̒l */
	w_p[c] = 0; c++; /* tick */

	fwrite(w_p,1,c,wr_hand);  /* c byte wrt */
	return (c);
}

/* ============================================== */

int __fastcall TForm1::closefmbin()
{
    fclose(wr_hand);
    return 0;
}

int __fastcall TForm1::chkexec()
{
    int f_chkloop=1; /* 1==loop,0==loopout */
    int retcode = -1;  /*߂li[*/
	int i;  /* for */
    int exe_sw;

    /* codenameɒǉꍇ ߃R[h ύX邱 */
    //rev<20010907p><20011231p><20020114p>
    char *codename[EXECMAX] = {"//","ch","{","\"","}","/*","*/","op","cr","sn"};

/*    printf("chkexec:");printf(rdworkptr);printf("\n");
//    printf("original: %d\n",rdworkptr);
*/
    while(f_chkloop)
    {
        switch(*rdworkptr)
        {
            case ' ': rdworkptr++;break;
            case 0x09:rdworkptr++;break;
            default : f_chkloop = 0;
        }

        if(rdworkptr >= (rdwork+LINEMAX)) f_chkloop = 0;
    }

    f_chkloop = 1;  /*for̔op(1==loop)*/
    for(i=0;i<EXECMAX;i++)
    {

        exe_sw=strncmp((char *)rdworkptr,codename[i],strlen(codename[i]));

        if(exe_sw == 0)
        {
            rdworkptr+=strlen(codename[i]); /*̈ʒuptrړ*/
            /*printf("strlen:%d ",strlen(codename[i]));*/

            //rev<20010126a>
            if(f_remskip==false && i != 6)
            {

                /* dv ߃R[h */
                switch(i) /*߃R[hɑ΂switch*/
                {
                    case 0: retcode = 0;
                            f_chkloop=0;  /*forv*/
                            break;  /*Rgߔ*/
                    case 1: /* ch񔭌*/
                            if(*rdworkptr >= '1' && *rdworkptr <= '0'+MAX_CH)
                            {
                                chval = *rdworkptr - 0x30;
                                retcode = 1; /*`lw肠*/
                                rdworkptr++;
                            }
                            else
                            {   retcode = -1;  /*`chR[h*/
                            }
                            f_chkloop=0;  /*forv*/
                            break;

                    case 2: case 3: case 4: case 7: /*rev <20010907p> */
                    case 8: case 9: /* add rev <20020114p> */
                            retcode = i;
                            f_chkloop=0;  /*forv*/
                            break;
                    //<20010126a>
                    case 5:
                            f_remskip=true;   // on
                            f_chkloop=0;  /* for break */
                            retcode = 5;  /* coment start */
                            break;
                    //<20010126a>
                    //case 6:
                    //        f_remskip=false;  //off
                    //        f_chkloop=0;  // for break
                    //        retcode = 6;  /* coment end */
                    //        break;
                }
            }
            else if(i ==6)
            {
                //<20010126a>
                f_remskip=false;  //off
                f_chkloop=0;  // for break
                retcode = 6;  /* coment end */
            }
        }
        if(f_chkloop == 0)break;  /*for*/
    }


    //<20010126a>
    if(f_remskip==true)
    {
        if(*rdworkptr == 0x0d)
        {    retcode = -1; } //oO(if܂)
        else
        {
            retcode = 5;  //RgX^[g
            rdworkptr++;  //̕ɂ
        }
    }

    /*bug*/
    if(retcode < 0 && *rdworkptr == 0x0d)
    {
        retcode = 0;
    }

/*    printf("retcode:%d\n",retcode);*/
    return (retcode);
}

int __fastcall TForm1::open_ch(int chno)
{
    if(ch_stack != 0) return -1;
    ch_stack = chno;  /*I[v`lԍL^*/
    return 0;
}
int __fastcall TForm1::cdecnv_old()
{
    int f_cdeloop;
    int ext_err = 0;  /*G[R[h*/
    int cyokuon;  /* <20010106p> */
    int length;  /* <20010114p> */
    int okutabu; /* <20010114p> */
    int okuta;  /* <20010114p> */

/*    printf("cdecnv : ");printf(rdworkptr);
    putchar('\n');
*/
    f_cdeloop = 1;  /* 1==loop, 0== loopout*/
    /*K(yі߉)*/
    while(f_cdeloop)
    {
        switch(*rdworkptr)
        {
			case ' ':case 0x09:	rdworkptr++;break; /* <20010114p>󔒔΂*/
            case 'C':case 'c':  /*h̏*/
                /*printf("c\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
                {   rdworkptr++;s_cdecnv(MEL_CS,l_cdecnv());}
                else if(*rdworkptr==':') /* <20010303p> */
                {   rdworkptr++;
                    int a = AscToDec16(rdworkptr);
                    if(a > 0)
                    {
                        if(ch_stack<=0 || ch_stack > MAX_CH)
                            {ext_err=-1;break;}
                        int c = MEL_C+(okutabu_ch[ch_stack-1]*12);
                        ext_err = s_cdestore(c ,a);
                    }
                    else {ext_err=-1;}
                }
                else{ext_err=s_cdecnv(MEL_C ,l_cdecnv());}
                break;

            case 'D':case 'd':  /*̏*/
                /*printf("d\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
                {   rdworkptr++;
                	s_cdecnv(MEL_DS,l_cdecnv());
                }
                else if(*rdworkptr == '-') /* <20010106p> */
                {
                    rdworkptr++;
		    ext_err=s_cdecnv(MEL_CS,l_cdecnv());
                }                       /* ܂ */
                else{ext_err=s_cdecnv(MEL_D ,l_cdecnv());}
                break;

            case 'E':case 'e':  /*~̏*/
                /*printf("e\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
			{ return 1;} /*\G[*/
                else if(*rdworkptr == '-') /* <20010106p> */
                {
                    rdworkptr++;
		    ext_err=s_cdecnv(MEL_DS,l_cdecnv());
                }                       /* ܂ */
                else{ext_err=s_cdecnv(MEL_E,l_cdecnv());}
                break;

            case 'F':case 'f':  /*t@̏*/
                /*printf("f\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
		{rdworkptr++;s_cdecnv(MEL_FS,l_cdecnv());}
                else{ext_err=s_cdecnv(MEL_F ,l_cdecnv());}
                break;

            case 'G':case 'g':  /*\̏*/
                /*printf("g\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
		{rdworkptr++;s_cdecnv(MEL_GS,l_cdecnv());}
                else if(*rdworkptr == '-') /* <20010106p> */
                {
                    rdworkptr++;
		    ext_err=s_cdecnv(MEL_FS,l_cdecnv());
                }                       /* ܂ */
                else{ext_err=s_cdecnv(MEL_G ,l_cdecnv());}
                break;

            case 'A':case 'a':  /*̏*/
                /*printf("a\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
		{rdworkptr++;s_cdecnv(MEL_AS,l_cdecnv());}
                else if(*rdworkptr == '-') /* <20010106p> */
                {
                    rdworkptr++;
		    ext_err=s_cdecnv(MEL_GS,l_cdecnv());
                }                       /* ܂ */
                else{ext_err=s_cdecnv(MEL_A ,l_cdecnv());}
                break;

            case 'B':case 'b':  /*V̏*/
                /*printf("b\n");*/
                rdworkptr++;
                if(*rdworkptr=='#' || *rdworkptr == '+') /* <20010106p> */
		{return -1;} /*\G[*/
                else if(*rdworkptr == '-') /* <20010106p> */
                {
                    rdworkptr++;
		    ext_err=s_cdecnv(MEL_AS,l_cdecnv());
                }                       /* ܂ */
                else{ext_err=s_cdecnv(MEL_B ,l_cdecnv());}
                break;

            case 'N':case 'n':  /* w <20010106p>*/
                rdworkptr++;
                if(*rdworkptr >= '0' && *rdworkptr <= '9')
                {
                    cyokuon = *rdworkptr - 0x30;
                    rdworkptr++;
                    if(*rdworkptr >= '0' && *rdworkptr <= '9')
                    {
                        cyokuon = cyokuon * 10;
                        cyokuon += *rdworkptr - 0x30;
                        rdworkptr++;
                    }

                    if(cyokuon <= 96)
                    {
						if(ch_stack >= 1 && ch_stack <= MAX_CH)
						{	length = length_ch[ch_stack-1];
                        	ext_err=s_cdestore(cyokuon,t_nagasa[length]);
						}
						else{ext_err=1;}
                    }
                    else
                    {
                        ext_err=1;
                    }
                }
                break;        /* ܂ */

            case 'R':case 'r':  /*x*/
                /*printf("r\n");*/
                rdworkptr++;
                ext_err=s_cdecnv(MEL_MU,l_cdecnv());
                break;

            case 'O':case 'o':  /*IN^[uύX*/
                /*printf("o\n");*/
                rdworkptr++;
                if(*rdworkptr >= '0' && *rdworkptr <= '7')
                {
                    okutabu = *rdworkptr - 0x30;  /*l*/
				    /* <20010114p> add */
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	okutabu_ch[ch_stack-1]=okutabu;	}
					else{ext_err=1;}

                    /*printf("okutabu:%d\n",okutabu); //debug*/
                    rdworkptr++;
                }
                else
                {
                    ext_err = 1;
                }
                break;

            case 'L':case 'l':  /*ύX*/
                /*printf("l\n");*/
                rdworkptr++;
                length = l_lencnv();
                if(length < 0)ext_err = 1;  /*err*/

				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	length_ch[ch_stack-1]=length;	}
				else{ext_err=1;}
                break;

            case '@':   /*yԍύX*/
                /*printf("@\n");*/
                rdworkptr++;
                ext_err = n_gakkicnv(); /* ʂ͊OϐgakkiɓĂ */
                if(ext_err == 0)
                {
                    s_ch_gakki(); /*yԍύX Oϐgakki */
                }
                break;

            case '>':   /*ނ <20010106p>*/
                rdworkptr++;

				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	okuta = okutabu_ch[ch_stack-1];
	                if(okuta < 7) { okuta++;okutabu_ch[ch_stack-1]=okuta;}
				}
				else{ext_err=1;}
                break;  /*܂<20010106p> */

            case '<':   /*ނ <20010106p>*/
                rdworkptr++;
				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	okuta = okutabu_ch[ch_stack-1];
	                if(okuta > 0){ okuta--;okutabu_ch[ch_stack-1]=okuta; }
				}
				else{ext_err=1;}
                break;  /*܂<20010106p> */

			/* <20010114p> add */
		    case 'V': case 'v':  /* volume */
				rdworkptr++;
				ext_err = n_gakkicnv();
				/*printf("vol:%d\n",ext_err); */
				//if(ext_err == 0 && gakki >= 0 && gakki <= MAX_VOLUME)
				if(ext_err == 0 && gakki <= MAX_VOLUME)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	volume_ch[ch_stack-1]=gakki;	/* OϐgakkiɓĂ */
						/* fm compiler <20010115p> */
						ext_err=s_cdestore(253,volume_ch[ch_stack-1]);
					}
					else{ext_err=1;}
				}
				else
				{	ext_err=1;
				}
				break;

			/* <20010115p> add */
		    case 'T': case 't':  /* tempo */
				rdworkptr++;
				ext_err = n_gakkicnv();
				if(ext_err == 0 && gakki >= MIN_TEMPO && gakki <= MAX_TEMPO)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	/* OϐgakkiɓĂ */
						/* fm compiler <20010115p> */
						ext_err=s_cdestore(252,gakki); /* tempo store */
					}
					else{ext_err=1;}
				}
				else
				{	ext_err=1;
				}
				break;

            // <20010127p> and
            case '&':
                rdworkptr++;
                if(*rdworkptr!='&') //AandȂ
                {
                    ext_err=s_cdestore(251,0); // and code store
                }
                else{ext_err=10;} //rev<20010127p>
                break;

            case '\"':rdworkptr++;f_cdeloop=0;  /* " */
                        /*printf("\nend cnv\n");*/
                        break;
            default: return 1;
        }
        if(rdworkptr >= rdwork+LINEMAX) f_cdeloop=0;
        if(ext_err != 0){ return ext_err;} //rev<20010127p>
    }
    return 0;
}
//----------------------------
int __fastcall TForm1::cdecnv()
{
    int f_cdeloop;
    int ext_err = 0;  /*G[R[h*/
    int cyokuon;  /* <20010106p> */
    int length;  /* <20010114p> */
    int okutabu; /* <20010114p> */
    int okuta;  /* <20010114p> */

    int cde_v = 0;  /* <20010304a> KR[hi[ */
    int f_cdev= 0;  /* <20010304a> 0<>̎cde_val */

/*    printf("cdecnv : ");printf(rdworkptr);
    putchar('\n');
*/
    f_cdeloop = 1;  /* 1==loop, 0== loopout*/
    /*K(yі߉)*/
    while(f_cdeloop)
    {
        switch(*rdworkptr)
        {
			case ' ':case 0x09:	rdworkptr++;break; /* <20010114p>󔒔΂*/
            case 'C':case 'c': cde_v=MEL_C;f_cdev=1; break; /*h*/
            case 'D':case 'd': cde_v=MEL_D;f_cdev=1; break; /**/
            case 'E':case 'e': cde_v=MEL_E;f_cdev=1; break; /*~*/
            case 'F':case 'f': cde_v=MEL_F;f_cdev=1; break; /*t@*/
            case 'G':case 'g': cde_v=MEL_G;f_cdev=1; break; /*\*/
            case 'A':case 'a': cde_v=MEL_A;f_cdev=1; break; /**/
            case 'B':case 'b': cde_v=MEL_B;f_cdev=1; break; /*V*/
            case 'N':case 'n': /* w <20010106p>*/
                rdworkptr++;
                cyokuon = AscToDec16(rdworkptr);
                if(cyokuon >= 0 && cyokuon <= 96)
                {
                    if(ch_stack >= 1 && ch_stack <= MAX_CH)
                    {	length = length_ch[ch_stack-1];
                        ext_err=s_cdestore(cyokuon,t_nagasa[length]);
                    }
                    else
                    {
                        ext_err=999; //ch I[vĂȂ
                    }
                }
                else
                {
                    ext_err=12;  //rev<20010315p>
                    f_cdeloop = 0;  //rev<20010315p>[v~
                    //debug
                    //ShowMessage("err12");
                }
                break;        /* ܂ */

            case 'R':case 'r':  /*x*/
                /*printf("r\n");*/
                rdworkptr++;
                ext_err=s_cdecnv(MEL_MU,l_cdecnv());
                break;

            case 'O':case 'o':  /*IN^[uύX*/
                /*printf("o\n");*/
                rdworkptr++;
                if(*rdworkptr >= '0' && *rdworkptr <= '7')
                {
                    okutabu = *rdworkptr - 0x30;  /*l*/
				    /* <20010114p> add */
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	okutabu_ch[ch_stack-1]=okutabu;	}
					else{ext_err=1;}

                    /*printf("okutabu:%d\n",okutabu); //debug*/
                    rdworkptr++;
                }
                else
                {
                    ext_err = 13;
                }
                break;

            case 'Q':case 'q':  /*ԕύX <20010321p>v0.00.05 */
                /*printf("o\n");*/
                rdworkptr++;
                if(*rdworkptr >= '1' && *rdworkptr <= '8')
                {
                    int q_val = *rdworkptr - 0x30;  /*l*/
					q_val--;  /* tableQƗp0`7ɂ */
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{
						ext_err=s_cdestore(250,q_val);
                    }
					else{ext_err=1;}

                    rdworkptr++;
                }
                else
                {
                    ext_err = 19;   /* \pG[R[h */
                }
                break;

            case 'L':case 'l':  /*ύX*/
                /*printf("l\n");*/
                rdworkptr++;
                length = l_lencnv();
                if(length < 0)ext_err = 14;  /*err*/

				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	length_ch[ch_stack-1]=length;	}
				else{ext_err=999;}
                break;

            case '@':   /*yԍύX*/
                /*printf("@\n");*/
                rdworkptr++;
                ext_err = n_gakkicnv(); /* ʂ͊OϐgakkiɓĂ */
                if(ext_err == 0)
                {
                    s_ch_gakki(); /*yԍύX Oϐgakki */
                }
                else{ ext_err = 15;}
                break;

            case '>':   /*ނ <20010106p>*/
                rdworkptr++;

				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	okuta = okutabu_ch[ch_stack-1];
	                if(okuta < 7) { okuta++;okutabu_ch[ch_stack-1]=okuta;}
				}
				else{ext_err=999;}
                break;  /*܂<20010106p> */

            case '<':   /*ނ <20010106p>*/
                rdworkptr++;
				/* <20010114p> add */
				if(ch_stack >= 1 && ch_stack <= MAX_CH)
				{	okuta = okutabu_ch[ch_stack-1];
	                if(okuta > 0){ okuta--;okutabu_ch[ch_stack-1]=okuta; }
				}
				else{ext_err=999;}
                break;  /*܂<20010106p> */

			/* <20010326a> add v0.00.05 */
    		case '{':
            	rdworkptr++;
            	if(sub_renpu() < 0)
                {	 /* Memo1->Lines->Add("error"); */
                	ext_err=20;
                }
	        	break;

			/* <20010114p> add */
		    case 'V': case 'v':  /* volume */
				rdworkptr++;
				ext_err = n_gakkicnv();
				/*printf("vol:%d\n",ext_err); */
				//if(ext_err == 0 && gakki >= 0 && gakki <= MAX_VOLUME)
				if(ext_err == 0 && gakki <= MAX_VOLUME)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	volume_ch[ch_stack-1]=gakki;	/* OϐgakkiɓĂ */
						/* fm compiler <20010115p> */
						ext_err=s_cdestore(253,volume_ch[ch_stack-1]);
					}
					else{ext_err=999;}
				}
				else
				{	ext_err=16;
				}
				break;

			/* <20010115p> add */
		    case 'T': case 't':  /* tempo */
				rdworkptr++;
				ext_err = n_gakkicnv();
				if(ext_err == 0 && gakki >= MIN_TEMPO && gakki <= MAX_TEMPO)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	/* OϐgakkiɓĂ */
						/* fm compiler <20010115p> */
						ext_err=s_cdestore(252,gakki); /* tempo store */
					}
					else{ext_err=999;}
				}
				else
				{	ext_err=17;
				}
				break;

            // <20010127p> and
            case '&':
                rdworkptr++;
                if(*rdworkptr!='&') //AandȂ
                {
                    ext_err=s_cdestore(251,0); // and code store
                }
                else{ext_err=10;} //rev<20010127p>
                break;

		    case '$':  /* panpot <20010830p> v0.00.06 */
				rdworkptr++;
				ext_err = n_gakkicnv();
				if(ext_err == 0 && gakki <= MAX_PAN)
				{
					if(ch_stack >= 1 && ch_stack <= MAX_CH)
					{	/* OϐgakkiɓĂ */
						ext_err=s_cdestore(249,gakki); /* panpot store */
					}
					else{ext_err=999;}
				}
				else
				{	ext_err=21;  /* panpot error No. */
				}
				break;

            case '\"':rdworkptr++;f_cdeloop=0;  /* " */
                        /*printf("\nend cnv\n");*/
                        break;
            default: return 1;
        }

        //==<20010304a>==================
        if(f_cdev != 0)  //KR[h̎(cdefgab)
        {
            rdworkptr++;

            if(*rdworkptr=='#' || *rdworkptr == '+') //<20010304a>
            {
                rdworkptr++;
                // N88BASIC K(B#͓IN^[uCł)
                if(cde_v < MEL_B){cde_v++;}
                else{cde_v =  MEL_C;}
            }
            else if(*rdworkptr=='-')
            {
                rdworkptr++;
                // N88BASIC K(C-͓IN^[uBł)
                if(cde_v > MEL_C){cde_v--;}
                else{cde_v =  MEL_B;}
            }

            if(*rdworkptr==':') /* <20010303p> */
            {
                rdworkptr++;
                int a = AscToDec16(rdworkptr);
                if(a > 0 && a<=255)
                {
                    if(ch_stack<=0 || ch_stack > MAX_CH)
                    {
                        ext_err=999;
                    }
                    else
                    {
                        int c = cde_v+(okutabu_ch[ch_stack-1]*12);
                        ext_err = s_cdestore(c ,a);
                    }
                }
                else {ext_err=18;}
            }
            else
            {
                ext_err=s_cdecnv(cde_v ,l_cdecnv());
            }

            f_cdev = 0;  //flag reset
        }
        //============================

        if(rdworkptr >= rdwork+LINEMAX) f_cdeloop=0;
        if(ext_err != 0)
        {
            //ShowMessage("ext_err != 0");
            return ext_err;
        } //rev<20010127p>
    }
    return 0;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::sub_renpu()
{
	int a;

	//debug disp
    //Memo1->Lines->Add("** start { **");

	//reset
	for(int i=0;i<MAX_RENPU;i++){ work_len[i]=0;work_key[i] = '\0';}

	a = a_cnt(work_key); //keyi[ret

    if(a <= 0)
    {
		//debug
		//Memo2->Lines->Add("a<=0:err");

    	return -1;	//error
    }
    else
    {
		int f_lp2 = true;
        while(f_lp2)
        {
           	if(*rdworkptr != ' '){ f_lp2 = false;}
            else{rdworkptr++;} //skip
        }
		//̏̓_~[gp
        //int m_len = 32;  //432
		int v_onpu = l_cdecnv(); //
		if(v_onpu < 0){	return -1;}

		//debug disp
        //Memo2->Lines->Add("v_onpu:"+IntToStr(v_onpu));

        int m_len = t_nagasa[v_onpu];
        int amari;  //܂
        int ans;  //؂ꂽ

        ans = m_len/a;
        amari = m_len - (ans*a);

		//debug disp
        //Memo2->Lines->Add("m_len:"+IntToStr(m_len));
        //Memo2->Lines->Add("ans:"+IntToStr(ans));
        //Memo2->Lines->Add("amari:"+IntToStr(amari));

    	for(int i=0;i<a;i++){ work_len[i]= ans;}

		//܂肪Ƃs␳
        if(amari >= 1)
        {
			int step = a/amari; //[vJEg擾
        	//debug disp
        	//Memo1->Lines->Add("step:"+IntToStr(step));
    	    for(int i=0,j=0;i < amari;i++,j+=step){ work_len[j]++;}  //inc
        }
    }

	//output
    int ext_err;
    for(int i=0;i<a;i++)
    {
    	ext_err = s_cdestore(work_key[i],work_len[i]);
		if(ext_err < 0)
        {
        	//debug
            //Memo2->Lines->Add("sub_renpu(){s_cdestore()}:err");
        	return -1;
        }
    }
	return 0;  //no error
}
//-----------------
int __fastcall TForm1::a_cnt(char *p)
{
	// *pɒԍi[
	int c=0;
    bool f_acntlp=true;

    if(ch_stack<=0 || ch_stack > MAX_CH) {return -1;}

	while(f_acntlp)
    {
		if(*rdworkptr=='\0' || *rdworkptr== 0x0d){ return -1;}  //err

		int cdekey=0,param1=0;
		int err_scde = sub_cdecnv(cdekey,param1);

        if(err_scde != 0)return -1; //err

	  	if(cdekey >= 1 && cdekey<= 12 && err_scde == 0)
        {
			*p = (char)(cdekey+(okutabu_ch[ch_stack-1]*12));
            p++;c++;
        }
        else if(cdekey == 0 && err_scde == 0)
        {
        	*p = 0;  //
            p++;c++;
        }
        else if(err_scde == 0 && cdekey >= 14)
        {
			switch(cdekey)
	        {
				case 14: *p = (char)param1;p++;c++;break; /* n */
                case 15: okutabu_ch[ch_stack-1]=param1;break; /* o */
                case 17: return -1;
                case 18: return -1;  /* @ */
                case 19: if(okutabu_ch[ch_stack-1]<7){
                			okutabu_ch[ch_stack-1]++;}break;  /* > */
                case 20: if(okutabu_ch[ch_stack-1]>0){
                			okutabu_ch[ch_stack-1]--;}break;  /* < */
                case 21: return -1;  /* v */
                case 22: return -1;  /* t */
                case 23: return -1;  /* & */
                case 24: return -1;  /* " */
	        }
		}

       	if(c>=MAX_RENPU){ return -1;} //err

        if(*rdworkptr == '}')
        {
        	f_acntlp=false;
			rdworkptr++;
        }
	}
	//debug disp
	//Memo1->Lines->Add("a_cnt retval:"+IntToStr(c));

	return c;
}
//----------------------------
//VKǔŊJ<20010325p>
//cdekey͋@\ԍ邽߂̕ϐAhX
//param1͋@\ɑ΂鐔li[邽߂̕ϐAhX
//cdekey=0:x,1`13܂ŉK,14:n,15:o,16:q,17:L,18:@
// 19:>,20:<,21:v,22:t,23:&,24:"
//param1ɂ͒l(0=),K:ԍ,o:q:L:@:v:t:l,
//     0  >,<,&,"
//return 0=no error,<>G[

int __fastcall TForm1::sub_cdecnv(int &cdekey,int &param1)
{
	char asc1;
    bool f_lp1 = true;
	int f_cdev = 0;  //p

    // #define rp rdworkptr

    /*K(yі߉)*/
	/* space skip */
	while(f_lp1)
    {
		if(*rdworkptr == ' ' || *rdworkptr == 0x09){rdworkptr++;}
        else{  	f_lp1 = false; }
    }

    cdekey = 0;  //reset

	asc1 = *rdworkptr;

    if(asc1 >= 'a' && asc1 <= 'z'){ asc1=(unsigned char)(asc1 & 0xdf);}

    switch(asc1)
    {
        case 'R':cdekey=MEL_MU;rdworkptr++; param1=l_cdecnv();break;/*x*/
	    case 'C':cdekey=MEL_C;f_cdev=1; break; /*h*/
	    case 'D':cdekey=MEL_D;f_cdev=1; break; /**/
        case 'E':cdekey=MEL_E;f_cdev=1; break; /*~*/
        case 'F':cdekey=MEL_F;f_cdev=1; break; /*t@*/
        case 'G':cdekey=MEL_G;f_cdev=1; break; /*\*/
        case 'A':cdekey=MEL_A;f_cdev=1; break; /**/
        case 'B':cdekey=MEL_B;f_cdev=1; break; /*V*/
        case 'N':rdworkptr++;cdekey=14;param1= AscToDec16(rdworkptr);
        		if(param1<0 && param1>96){return 1;}break; /* */
        case 'O':rdworkptr++;cdekey=15;param1=AscToDec16(rdworkptr);
        		if(param1<0 && param1>7){return 1;}break;/*octύX*/
        case 'Q':rdworkptr++;cdekey=16;param1=AscToDec16(rdworkptr);
        		if(param1<1 && param1>8){return 1;}break;/*ύX*/
        case 'L':rdworkptr++;cdekey=17;param1=l_lencnv();
        		if(param1<0){return 1;}break;/*ύX*/
        case '@':rdworkptr++;cdekey=18;param1=AscToDec16(rdworkptr);
        		if(param1<0 && param1>127){return 1;}break;/*yԕύX*/
        case '>':cdekey=19;rdworkptr++;break;/*ނ*/
        case '<':cdekey=20;rdworkptr++;break;/*ނ <20010106p>*/
	    case 'V':rdworkptr++;cdekey=21;param1=AscToDec16(rdworkptr);
        		if(param1<0 && param1>MAX_VOLUME){return 1;}break;/* volume */
	    case 'T':rdworkptr++;cdekey=22;param1=AscToDec16(rdworkptr);
        		if(param1<10 && param1>240){return 1;}break;/* tempo */
        case '&':rdworkptr++;cdekey=23;break;
        case '\"':rdworkptr++;cdekey=24;break; /* " */
        default: return 1;
    }

    if(f_cdev != 0)  //KR[h̎(cdefgab)
    {
        rdworkptr++; //cdełłɊŶ

        if(*rdworkptr=='#' || *rdworkptr == '+') //<20010304a>
        {   rdworkptr++; if(cdekey < MEL_B){cdekey++;}else{cdekey=MEL_C;} // N88
        }
        else if(*rdworkptr=='-')
        {   rdworkptr++; if(cdekey > MEL_C){cdekey--;}else{cdekey=MEL_B;}//N88
        }
        //̍s͂̊֐Ń[vȂsvȂ̂ŃRg<20020114p>
//        f_cdev = 0;  //flag reset
		param1 = l_cdecnv();
    }
    //============================
	return 0;
}
//------------------
void __fastcall TForm1::s_ch_gakki()
{
    if(ch_stack == 0) return; /*I[v*/
    if(ch_stack > MAX_CH) return; /* ch over */

    unsigned char *p;
    p= chxmem[ch_stack-1];

    p[chxcnt[ch_stack-1]]=(unsigned char)254;  /*FύX*/
    chxcnt[ch_stack-1]++;
    p[chxcnt[ch_stack-1]]=gakki;
    chxcnt[ch_stack-1]++;
}

int __fastcall TForm1::close_ch()
{
    /*printf("close_ch\n");*/
    if(ch_stack == 0) return -1;  /*I[vĂȂ̂ɃN[Y*/
    ch_stack = 0;  /*N[Y*/
    return 0;
}

void __fastcall TForm1::out_exterr(int errcode)
{
    //rev<20010127p>
	//rev<20010318a>

    AnsiString As1,As2;

    As2 = " *** ";

    switch(errcode)
    {
       case 1 : As1 = "ǂłȂ߂܂";break;
       case 10 :As1 = "& ͘Aŕׂ܂";break;
       case 11 :As1 = "& PƂł͗pł܂";break;
       case 12 :As1 = " N? ͈̔͂ 0`96";break;
       case 13 :As1 = " O? ͈̔͂ 0`7";break;
       case 14 :As1 = " L? ŕslgp";break;
       case 15 :As1 = " @? ͈̔͂ 0`127";break;
       case 16 :As1 = " V? ͈̔͂ 0`16";break;
       case 17 :As1 = " T? ͈̔͂ 10`250";break;
       case 18 :As1 = " :  ͈̔͂ 1`255";break;
       case 19 :As1 = " Q? ͈̔͂ 1`8";break;
       case 20 :As1 = " {} AwɌ肪";break;
       case 21 :As1 = " $? ͈̔͂ 0`127";break; /* v0.00.06 */
       case 22 :As1 = "op  ')'ŏIKv܂";break; /* v0.00.08 */
       case 23 :As1 = "op  Y鐧䖽߂͂܂";break; /* v0.00.08 */
       case 24 :As1 = "cr  ')'ŏIKv܂";break; /* v0.00.09 */
       case 25 :As1 = "63Byte܂(߈ᔽ)";break; /* v0.00.09 */
       case 26 :As1 = "sn  ')'ŏIKv܂";break; /* v0.00.10 */
       case 27 :As1 = "127Byte܂(߈ᔽ)";break;/* v0.00.10 */
       case 999:As1 = "ch I[vĂ܂";break;
       default: As1 = "̑̃G[";break;
    }
	Memo2->Lines->Add(As2+As1+As2);
}

int __fastcall TForm1::n_gakkicnv()
{
    int atai = AscToDec16(rdworkptr);

/*l*/
    if(atai > 255) return -1;  /*over flow*/

    gakki = (unsigned char)atai; /*߂*/
    return 0;
}

inline int __fastcall TForm1::l_lencnv()
{
    int adjust = 0;  //_t̏ꍇ͒
    int retval;  //߂lp
    int len = AscToDec16(rdworkptr);

    if(len < 0)return -1;  //err

    switch(len)
    {
        case 1:  retval = L_1; break;
        case 2:  retval = L_2; break;
        case 4:  retval = L_4; break;
        case 8:  retval = L_8; break;
        case 16: retval = L_16; break;
        case 32: retval = L_32; break;
        case 64: retval = L_64; break;
        case 128:retval = L_128; break;
        default :return -1;
    }

    if(*rdworkptr == '.' && len < 128)
    {
        adjust = 1;
        rdworkptr++;  //next ptr
    }
    else if(*rdworkptr == '.' && len == 128)
    {
        return -1;  //err
    }
    return (retval-adjust);
}
//------------------------------------------------
//-----<20010214a>--l_cdecnv()ǔ(G~[^)---
inline int __fastcall TForm1::l_cdecnv()
{
    int retcode;

    retcode = l_lencnv();  /* ߂lɒ */

    if(retcode < 0) /* lw肪Ȃ(߂l}CiX) */
	{
		/* <20010114p> add */
		if(ch_stack >= 1 && ch_stack <= MAX_CH)
		{
			retcode = length_ch[ch_stack-1];
		}
		else
		{
			retcode = -1;
		}
	}
    return (retcode);
}
//-------------------------------
int __fastcall TForm1::s_cdecnv(int doremi,int onpu)
{
    int onkai;
    char *ch_ptr;
    unsigned long ch_count;
    int nagasa;
    int okutabu;  /* <20010114p> */

	/* <20010114p> add */
	if(ch_stack >= 1 && ch_stack <= MAX_CH)
	{
		okutabu = okutabu_ch[ch_stack-1];
	}
	else
	{
		return -1;  /* error */
	}

    /*h~R[h特KvZ*/
    if(doremi != 0)
	{	onkai = (okutabu*12)+doremi;
    }
    else
	{	onkai = 0;  /*w*/
	}

    /*R[h̒߂*/
    if(onpu >= LEN_MAX || onpu < 0){return -1;}  /*G[*/

    nagasa = t_nagasa[onpu];  /*̒擾*/

	/*debug*/
	/*printf("ch_stack:%d\n",ch_stack);*/

    /*w`l0̂Ƃ̓`lw*/
    if(ch_stack == 0) return -1;  /*G[*/

    ch_count = chxcnt[ch_stack-1];
    ch_ptr =(char*)chxmem[ch_stack-1];
    chxcnt[ch_stack-1]+=2;

	/*printf("s_cdecnv 1\n");*/
    /*R[hI[o[t[*/
    if(ch_count >= CH_MEMMAX-1-2)
    {
        Memo2->Lines->Add(" -> ch"+IntToStr(ch_stack)+
                " mۗ̈:"+IntToStr(CH_MEMMAX-1-2)+"bytez");
        return -1;
    }
    ch_ptr[ch_count] = (unsigned char)onkai;
    ch_ptr[ch_count+1]=(unsigned char)nagasa;

    return 0;
}

/* ڊechɊi[ <20010106p>*/
int __fastcall TForm1::s_cdestore(int cdecode,int nagasa)
{
    unsigned char *ch_ptr;
    unsigned long ch_count;

    if(cdecode > 255 || nagasa > 255)
    {
        return -1;  /* err */
    }

    /*w`l0̂Ƃ̓`lw*/
    if(ch_stack == 0) return -1;  /*G[*/

    ch_count = chxcnt[ch_stack-1];
    ch_ptr = chxmem[ch_stack-1];
    chxcnt[ch_stack-1]+=2;

    /*R[hI[o[t[*/
    if(ch_count >= CH_MEMMAX-1-2) return -1;

    ch_ptr[ch_count] = (unsigned char)cdecode;
    ch_ptr[ch_count+1]=(unsigned char)nagasa;

    return 0;
}
//=================================================================
//=================================================================

void __fastcall TForm1::Open1Click(TObject *Sender)
{
    SpeedButton1->Click();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N1Click(TObject *Sender)
{
	if(SaveDialog1->Execute() == true)
	{   //t@Cw肳ꂽƂs
//        RichEdit1->Lines->SaveToFile(SaveDialog1->FileName.c_str());

		//<20020609p> v0.00.10a   bakt@C쐬
        //bakt@C݂΂ɍ폜
		AnsiString removefname;
		removefname = ChangeFileExt(SaveDialog1->FileName , ".bak");
		//Debug
        //ShowMessage("rmf:"+removefname+","+"sfm:"+sourcefname);
        //remove ( sourcefname.bakt@C )
		remove(removefname.c_str());
		//rename ( sourcefname.fms sourcefname.bakɕύX )
        rename(SaveDialog1->FileName.c_str(), removefname.c_str());

		//<20020212p> win2000 ---
		Memo1->Lines->SaveToFile(SaveDialog1->FileName.c_str());
		//-----------------------
        strncpy(sourcefname,SaveDialog1->FileName.c_str(),MAXPATH-2);
        f_save = true; /* save  */
        f_saveend = true; /* save end */
        StatusBar1->Panels->Items[2]->Text="";
    	AnsiString f1;
        f1 = ChangeFileExt(SaveDialog1->FileName, ".mid");
        strncpy(midfname,f1.c_str(),MAXPATH-2);
        strncpy(bmidfname,f1.c_str(),MAXPATH-2);
    }
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Save1Click(TObject *Sender)
{
    if(f_save == true)
    {
//        RichEdit1->Lines->SaveToFile(sourcefname);

        //<20010308p> rev 0.00.04====
        if(f_saveend == false)
        {
			//<20020609p> v0.00.10a   bakt@C쐬
            //bakt@C݂΂ɍ폜
			AnsiString removefname;
			removefname = ChangeFileExt(sourcefname , ".bak");
			//Debug
            //ShowMessage("rmf:"+removefname+","+"sfm:"+sourcefname);
            //remove ( sourcefname.bakt@C )
			remove(removefname.c_str());
			//rename ( sourcefname.fms sourcefname.bakɕύX )
            rename(sourcefname , removefname.c_str());

			//<20020212>win2000-
			Memo1->Lines->SaveToFile(sourcefname);
            //------------------
            f_saveend=true;
        }
        StatusBar1->Panels->Items[2]->Text="";
        //===========================

    }
    else
    {
        N1Click(this);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
	MediaPlayer1->Wait = False;
//    MediaPlayer1->DeviceType = dtSequencer;
    StatusBar1->Panels->Items[2]->Text="";
//    RichEdit1->MaxLength=MAXREDSIZE;      //ҏW\ȃTCYύX
//    Memo1->MaxLength=64000;      //ҏW\ȃTCYύX

	// <20020212p> win2000 -----
	Memo1->MaxLength=MAXREDSIZE;      //ҏW\ȃTCYύX
	//---------------------------

    /* XvbVEBhE\ <20010213a> */
	Tmidlogo *midlogo = new Tmidlogo(this);
    midlogo -> Show();
    Application -> ProcessMessages();

//֘AÂNɑΉ邽߂̏<v0.00.05c>20010826p
    AnsiString a;  //option check
    AnsiString Fname;  //filename(path add)
    for(int i=1;i<=ParamCount();i++)  // 0͎̖O,1
    {
        a = ParamStr(i).SubString(0,1);  //1Ԗ1擾
        if(a != '/' && a!= '-')  //optionL
        {
            //IvVłȂ
            OpenDialog1->FileName = ParamStr(i);  //filename copy
            //filẽI[vɎsꍇ̔ v0.00.05c <20010828p>
            bool f_fopen = true;   //s(true=,false=s)
            try
            {
               //<20020212p> Win2000 ------
			Memo1->Lines->LoadFromFile(OpenDialog1->FileName.c_str());
			//---------------------------
            }
            catch(...)
            {
                Application->MessageBox("OPENł܂",NULL,MB_ICONSTOP);
                f_fopen = false;  //s
            }

            //I[vłꍇ
            if(f_fopen == true)
            {
                OpenFileAfter();  //fileopenɍs̊֐
            }
            else //łȂƂ
            {
                NotOpenFileAfter();  //fileopenłȂɍs̊֐
            }
        }
        else
        {
            //IvV
            //݋NIvV͂Ȃߏ
        }
    }

    //hbOhbvt@C擾p(v0.00.05c <20010827a>)
    DragAcceptFiles(Handle,true);
/*
//ݒ𔽉f(cfgŕۑĂꍇ܂)
    if(f_autosave == true){   N16->Click();}   //㏑ۑ
    if(f_playloop == true){   N13->Click(); }  //t[v
    if(f_numberon == true){   N17->Click(); }  //sԍon
    if(f_form_max == true){   WindowState=wsMaximized;} //ő剻

    switch(fontsize_r)
    {
        case 0: N8p1->Click() ;break; //
        case 1: N10p1->Click() ;break; //
        case 2: N12p1->Click();break; //
        default:N8p1->Click();
    }
*/

	//rev<20010321a> IME܂߂̏ꂽ߂̕␳
    //ChangeFontSize֐ŗOiNj߂̑Ή

	//Idle֐ֈړ <20010523a>
	/*
	try{
	    WncRichEdit1->SetFocus();
	}
    catch(...)
    {
    }
    */
    //===================

	//obNAbvJn<20020611a> v0.00.10a
    Timer1->Enabled = true;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::MediaPlayer1Notify(TObject *Sender)
{
//    Form2->Close();
    if(SpeedButton5->Down==false && Form2->Timer1->Enabled==true)
    {
        if(MediaPlayer1->Position>=MediaPlayer1->TrackLength[1])
        {
            Form2->Close();
        }
    }
    else if(SpeedButton5->Down==true && Form2->Timer1->Enabled==true)
    {
        if(MediaPlayer1->Position>=MediaPlayer1->TrackLength[1])
        {
            if(MediaPlayer1->TrackLength[1]<=0)
            {   return;} //<20010124p>[vh~
            MediaPlayer1->Position=0;
            MediaPlayer1->Play();
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton3Click(TObject *Sender)
{
    Save1Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Close1Click(TObject *Sender)
{
//    int ssize = RichEdit1->Text.Length();

	//<20020212p> win2000 --------
	int ssize;
	ssize = Memo1->Text.Length();
	//----------------------------

    if(f_saveend == false && ssize > 0)
    {
        f_CloseCancel = false;   //falseCancelĂȂ<20011231p>

    	int RetValue = Application -> MessageBox("\[XύXĂ܂"
            "\nۑ܂H",
          "mF",MB_ICONQUESTION | MB_YESNOCANCEL);

    	if(RetValue == IDYES)
        {
            Save1Click(this);
    	}
        else if(RetValue == IDCANCEL)
        {
            f_CloseCancel = true;  //close̓LZ<20011231p>
            return;
        }
    }

    Memo2->Lines->Clear();  //RpC̃bZ[W

//    RichEdit1->Clear();

	//<20020212p> win2000 ---------
	Memo1->Clear();  /* reset */
	//-----------------------------

    //v0.00.05c<20010827a>0͕\Ȃ悤ɉ
    if(ssize > 0)
    {
        Memo2->Lines->Add(" -> \[X̃TCY : "+IntToStr(ssize)+
            " oCg");
    }

    f_saveend = true;
    f_save = false;
    StatusBar1->Panels->Items[2]->Text="";
}
//---------------------------------------------------------------------------





void __fastcall TForm1::N10p1Click(TObject *Sender)
{
//    RichEdit1->Font->Size=((TMenuItem *)Sender) -> Tag;

	//<20020212p> win2000 ----
	Memo1->Font->Size=((TMenuItem *)Sender) -> Tag;
    //-------------------------

    N8p1  ->Checked =false; //reset
    N10p1 ->Checked =false;
    N12p1 ->Checked =false;

    ((TMenuItem *)Sender) -> Checked = true;

    switch ( ((TMenuItem *)Sender)->Tag)
    {
        case 10: SpeedButton8 ->Click();SpeedButton8 ->Down=true; break;
        case 14: SpeedButton9 ->Click();SpeedButton9 ->Down=true; break;
        case 20: SpeedButton10->Click();SpeedButton10->Down=true; break;
        default: SpeedButton8 ->Click();
    }
//    ChangeFontSize();
}
void __fastcall TForm1::ChangeFontSize()
{
	//<20020212p> win2000-------
// 	PaintBox1->Canvas->Font=Memo1->Font;
	//---------------------------
//    PaintBox1->Canvas->Font->Color=clHighlightText;
    //s(6ŌvZ)
//    int Hsize = PaintBox1->Canvas->TextWidth("000000");
//    Panel1->Width = Hsize+20;

    //tHgTCYςƂ͏Ƃ
//    TRect NewRect = Rect(0, 0, PaintBox1->Width,PaintBox1->Height);
//    PaintBox1->Canvas->Brush->Color = clHighlight;
//    PaintBox1->Canvas->FillRect(NewRect);
    OutPutCursorPos();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::midi1Click(TObject *Sender)
{
    if(f_save == true)
    {
        Form2->Close(); //<20010127a>
        f_smfcreate = true;  /* standard midi file create */
        N4Click(this);
        f_smfcreate = false; /* standard midi file not create */

        //SMF쐬𒼐ډƂ̑Ή <20011231p> v0.00.09
        if(f_errcreate == false)
        {
            Application->MessageBox("X^_[hmidit@C쐬I","",
                    MB_OK);
        }
    }
    else
    {
        Application->MessageBox("OĕۑĂ\nsĂ",
                    "",MB_ICONSTOP);
    }
}
//---------------------------------------------------------------------------










void __fastcall TForm1::SpeedButton4Click(TObject *Sender)
{
    midi1Click(this);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    //<20010124p>======
    Form2->Timer1->Enabled=false; // timer stopped
    MediaPlayer1->Close();
    TmpClose();
    //=================

    //<20010309p>===============
	//<20020212p> win2000 ---
	int ssize;
	ssize = Memo1->Text.Length();
    //------------------------

    if(f_saveend == false && ssize > 0)
    {
    	int RetValue = Application -> MessageBox("\[XύXĂ܂"
            "\nۑ܂H",
          "mF",MB_ICONQUESTION | MB_YESNOCANCEL);

    	if(RetValue == IDYES)
        {
            Save1Click(this);
            if(f_saveend == false)
                { CanClose = false; }  //Ô߃_CAOcancel
    	}
        else if(RetValue == IDCANCEL)
        {
            CanClose = false;
        }
    }
    //===========================
//    Close1Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::midcomp1Click(TObject *Sender)
{
	Application->HelpFile = ChangeFileExt(Application -> ExeName , ".CHM");
	Application->HelpShowTableOfContents();
//	Application->HelpCommand(HELP_FINDER, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N13Click(TObject *Sender)
{
    if(SpeedButton5->Down==false)
    {
        SpeedButton5->Down=true; //[v{^
        N13->Checked=true;  //t[v
    }
    else
    {
        SpeedButton5->Down=false;
        N13->Checked=false;
    }
}
//---------------------------------------------------------------------------





void __fastcall TForm1::GotoLastClick(TObject *Sender)
{
//    int zz = RichEdit1->Text.Length();
//    RichEdit1->Perform(EM_SETSEL,zz,zz);
	// <20020212p> win2000 --------
	int zz = Memo1->Text.Length();
	Memo1->Perform(EM_SETSEL,zz,zz);
	//-----------------------------

	SetLineScr();  //<20020214p>Win2000Ή
    OutPutCursorPos();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Copy1Click(TObject *Sender)
{
//    RichEdit1->Perform(WM_COPY,0,0);

	//<20020212p> win2000-----
	Memo1->Perform(WM_COPY,0,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Paste1Click(TObject *Sender)
{
    AnsiString As1;

    if (Clipboard()->HasFormat(CF_TEXT))
    {
        As1 = Clipboard()->AsText;
        Clipboard()->AsText=As1;
        Application->ProcessMessages();
    }

	//<20020212p> win2000------
	Memo1->PasteFromClipboard();
	//-------------------------

//    RichEdit1->Perform(WM_PASTE,0,0);
//    Memo1->Perform(WM_PASTE,0,0);
//    WncRichEdit1->Perform(WM_PASTE,0,0);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Cut1Click(TObject *Sender)
{
//    RichEdit1->Perform(WM_CUT,0,0);

	//<20020212p> win2000 ----
	Memo1->Perform(WM_CUT,0,0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Delete1Click(TObject *Sender)
{
//    RichEdit1->Perform(WM_CLEAR,0,0);
	//<20020212p> win2000 ----
	Memo1->Perform(WM_CLEAR,0,0);
    //------------------------
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SelectAll1Click(TObject *Sender)
{
//    RichEdit1->SelectAll();

	// <20020212p> win2000 ---
	Memo1->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Undo1Click(TObject *Sender)
{
//    RichEdit1->Perform(EM_UNDO,0,0);
	// <20020212p> win2000 ---
	Memo1->Perform(EM_UNDO,0,0);
    //-------------------------
}
//---------------------------------------------------------------------------
void __fastcall TForm1::SetLineScr()
{
	//<20020214p>win2000Ή
	//J[\̂sʒu𓾂
	int p=Memo1->Perform(EM_LINEFROMCHAR,Memo1->SelStart,0);
	//ԏ̍sʒu
	p-= Memo1->Perform(EM_GETFIRSTVISIBLELINE,0,0);
	//XN[
	Memo1->Perform(EM_LINESCROLL,0,p);
}
//---------------------------------------
void __fastcall TForm1::GotoStartClick(TObject *Sender)
{
//    RichEdit1->Perform(EM_SETSEL,0,0);
	//<20020212p> win2000 ----
	Memo1->Perform(EM_SETSEL,0,0);
    //------------------------
	SetLineScr();  //<20020214p>Win2000Ή
    OutPutCursorPos();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N6Click(TObject *Sender)
{
    GotoLine->Edit1->SelectAll();
    int mrsult = GotoLine->ShowModal();
//    RichEdit1->SetFocus();

	//<20020212p> win2000 ---
	Memo1->SetFocus();
	//------------------------

	int jumpbyte = GotoLine->Tag;

	if(jumpbyte >= 0 && mrsult == mrOk)
	{
//        RichEdit1->SelStart=jumpbyte;

		//<20020212p> win2000 ---
		Memo1->SelStart=jumpbyte;
		//-----------------------
	}
	else if(jumpbyte < 0 && mrsult == mrOk)
	{
//        int MaxLine = RichEdit1->Lines->Count;

		//<20020212p> win2000 ---
		int MaxLine;
		MaxLine = Memo1->Lines->Count;
		//------------------------
		AnsiString Me1 = "w肵sԍ͂Ȃ(ő ";
		Me1 += IntToStr(MaxLine+1)+"s)";
		Application->MessageBox(Me1.c_str(),NULL,MB_ICONSTOP);
	}
//    RichEdit1->SelLength=jumpbyte;
	SetLineScr();  //<20020214p>Win2000Ή
}
//---------------------------------------------------------------------------


void __fastcall TForm1::N16Click(TObject *Sender)
{
    if(SpeedButton6->Down==false)
    {
        SpeedButton6->Down=true;   //㏑ۑ{^
        N16->Checked=true; //㏑ۑ
    }
    else
    {
        SpeedButton6->Down=false;
        N16->Checked=false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton6Click(TObject *Sender)
{
    if(N16->Checked==false)
    {
        N16->Checked=true;
    }
    else
    {
        N16->Checked=false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton5Click(TObject *Sender)
{
    if(N13->Checked==false)
    {
        N13->Checked=true;  //t[v
    }
    else
    {
        N13->Checked=false;
    }
}
//---------------------------------------------------------------------------




void __fastcall TForm1::FormKeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	abaksttim = IDLATBTIM;   //Key𓮂̂ŗVт߂

    if(Key==VK_PAUSE)
    {
        Form2->Close();
    }

    if(Key==VK_F8)
    {
        if(Form2->Visible==true)
        {
            Form2->SetFocus();
        }
    }

}
//---------------------------------------------------------------------------
//w肵Ԓn̕𐔒lɕϊ
inline int __fastcall TForm1::AscToDec16(unsigned char *&p)
{
    int a=0;    //ϊli[邽߂̕ϐ
    int i;      //JEgyforp

    for(i=0;i<5;i++,p++)                //ő5Ƃ邽i<5
    {
        if(*p < '0' || *p > '9')break;  //lȊOłbreak
        a *= 10;                        //グ
        a += (*p&(unsigned char)0x0f);  // 4bit mask( upper 4bit clear)
    }
    if(i==0)return -1;                  //ŏ琔lłȂƂG[
    if(a > 65535) a=65535;              //16bitEl𒴂ꍇ
    return a;
}


void __fastcall TForm1::WMPaint(TWMPaint &Msg)
{
    OutPutCursorPos();    
//    OutPutLinePos();
    TForm::Dispatch(&Msg);

}

//POiT̃AXL[R[hɕϊwԒnɏɊi[
void __fastcall TForm1::Dec2Asc16(char *p,int i)
{
	unsigned int a,b,c;
    // int i;  //counter

    //special custom
	if(i>=100000)
    {
        int work1;
        work1=i;

        work1=work1/100000*100000;
        i=i-work1;  // line No. loop
    }

//    a = (unsigned short)i;
    a = (unsigned int)i;  //special custom

    c=10000;  //max 99999
    for(i=0; i<5; i++) // i<55͍ő包
    {	b=(unsigned int)(a/c);
    	a=(unsigned int)(a-c*b);
    	b=(unsigned int)(b+'0');
    	*p=(char)b;
    	p++;
    	c=(unsigned)(c/10);
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormPaint(TObject *Sender)
{
	OutPutCursorPos();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::PopupMenu1Popup(TObject *Sender)
{
    bool CanUndo;

    //UndoԂύX
	//<20020212p> win2000---
	CanUndo = Memo1->Perform(EM_CANUNDO,0,0);
	//----------------------

    if(CanUndo == true)
    {
        Undo1->Enabled=true;
        Undo2->Enabled=true;
    }
    else
    {
        Undo1->Enabled=false;
        Undo2->Enabled=false;
    }

	int sellength;  //<20020212p>win2000
	sellength = Memo1->SelLength;

//    if(WncRichEdit1->SelLength <= 0)
	if(sellength <= 0)  //rev<20020212p>
    {
        Copy1->Enabled = false;
        Copy2->Enabled = false;
        Cut1 ->Enabled = false;
        Cut2 ->Enabled = false;
        Delete1->Enabled=false;
        Delete2->Enabled=false;
    }
    else
    {
        Copy1->Enabled = true;
        Copy2->Enabled = true;
        Cut1 ->Enabled = true;
        Cut2 ->Enabled = true;
        Delete1->Enabled=true;
        Delete2->Enabled=true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::N17Click(TObject *Sender)
{
    if(SpeedButton7->Down==false)
    {
        SpeedButton7->Down=true; //sԍ{^
        N17->Checked=true;  //sԍ
//        Panel1->Visible=true; // gp

        //XN[o[̃oO<20010310p>v0.00.04a
		//<20020212p> win2000-----
		Memo1->Perform(EM_SCROLL,SB_LINEDOWN,0);
		Memo1->Perform(EM_SCROLL,SB_LINEUP,0);
		//------------------------
	}
	else
	{
		SpeedButton7->Down=false;
		N17->Checked=false;
//		Panel1->Visible=false; // false =gp

		//XN[o[̃oO<20010310p>v0.00.04a
		//<20020212p> win2000-----
		Memo1->Perform(EM_SCROLL,SB_LINEDOWN,0);
		Memo1->Perform(EM_SCROLL,SB_LINEUP,0);
		//-------------------------
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SpeedButton7Click(TObject *Sender)
{
    if(SpeedButton7->Down==false)
    {
        N17->Checked=false;  //sԍ
//        Panel1->Visible=false; // false =gp

        //XN[o[̃oO<20010310p>v0.00.04a
		//<20020212p> win2000 ---
		Memo1->Perform(EM_SCROLL,SB_LINEDOWN,0);
		Memo1->Perform(EM_SCROLL,SB_LINEUP,0);
		//-----------------------
    }
    else
    {
        N17->Checked=true;
//        Panel1->Visible=true; // true =gp

        //XN[o[̃oO<20010310p>v0.00.04a
		//<20020212p> win2000 ---
		Memo1->Perform(EM_SCROLL,SB_LINEDOWN,0);
		Memo1->Perform(EM_SCROLL,SB_LINEUP,0);
        //-----------------------
    }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::SpeedButton8Click(TObject *Sender)
{
	//IME܂߈uႤƂɃtH[JX𓖂Ă
    //C++BuildersCPUEBhE\ꎞ~
    //rev<20010321a>============
	//rev<20010523a>===
    if(Form1->Active==true)
    {
		try
	    {
		    Memo2->SetFocus();

			//<20020212p> win2000 ---
			Memo1->SetFocus();
			//-----------------------
		}
		catch(...)
		{
		}
	}
	//==========================
	//<20020212p>win2000 -----
	Memo1->Font->Size=((TSpeedButton *)Sender) -> Tag;
	//-------------------------

    //rev
    Memo2->Font->Size=((TSpeedButton *)Sender) -> Tag;

    N8p1 ->Checked=false;  //reset
    N10p1->Checked=false;
    N12p1->Checked=false;


    switch ( ((TMenuItem *)Sender)->Tag)
    {
        case 10: N8p1 ->Checked=true; break;
        case 14: N10p1->Checked=true; break;
        case 20: N12p1->Checked=true; break;
        default: N8p1 ->Checked=true;
    }

    ChangeFontSize();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::N19Click(TObject *Sender)
{
    //tȌԂ𔽉f
    MdcompOption->CheckBox1->Checked=false; //reset
    MdcompOption->CheckBox2->Checked=false; //reset
    MdcompOption->CheckBox3->Checked=false; //reset
    MdcompOption->CheckBox4->Checked=false; //reset
    MdcompOption->CheckBox5->Checked=false; //reset
	MdcompOption->RadioGroup2->ItemIndex=0; //reset <20010322a>

    if(f_autosave == true){ MdcompOption->CheckBox1->Checked=true;}
    if(f_playloop == true){ MdcompOption->CheckBox2->Checked=true;}
    if(f_numberon == true){ MdcompOption->CheckBox3->Checked=true;}
    if(f_form_max == true){ MdcompOption->CheckBox4->Checked=true;}
	if(f_q_def7 == true){ MdcompOption->RadioGroup2->ItemIndex=1;}//<20010322a>
    if(f_auto_lr == true){ MdcompOption->CheckBox5->Checked=true;}//<20010906p>
    //tHgTCYw
    MdcompOption->RadioGroup1->ItemIndex = fontsize_r;


    int RetVal = MdcompOption -> ShowModal();  //ݒʕ\

    if(RetVal == mrOk)
    {
        if(WrtCfgData())
        {
            Application->MessageBox("ۑɎs܂",NULL,MB_ICONSTOP);
        }
        else
        {
            Application->MessageBox("ݒۑ܂.",
            "mF",MB_OK);
        }
    }
}
//---------------------------------------------------------------------------
bool __fastcall TForm1::WrtCfgData()
{
    //mdcomp32.cfgɏݒL^

    int cfghand;       //cfg̃nhۑp

    char cfg_dat[CFGSIZE+1];  //ۑf[^ꏊ
    char *p1;         //ۑp|C^
//    unsigned char *p2;  //ۑp|C^

    bool RetTrueFalse; //true͕ۑs,falseۑ

    for(int i=0;i<CFGSIZE;i++)
    {   cfg_dat[i] = '\0'; }

    p1 = cfg_dat;

    p1[0] = 'M'; p1[1]= 'D'; p1[2] = 'C'; p1[3] = 'O';
    p1[4] = 'M'; p1[5] = 'P';
    p1[6] = '0'; p1[7] = '0'; p1[8] = '0';
    p1[9] = 0x0d;  // cr
    p1[10]= 0x0a;  // lf
    p1[11]= 0x1a;  //eof

    unsigned char a=0;  //flagێp

	//ݒ <20010322a> rev<20010906p>
    f_autosave = false;
	f_playloop = false;
    f_numberon = false;
    f_form_max = false;
    f_q_def7   = false;
    f_auto_lr  = false;

    // 76543210
    // qlmscccc  <-ێ(c=checkbox,s=font ,m=font ,l=font 
    // 21114321  <-liYԍj
    if(MdcompOption->CheckBox1->Checked==true)
    	{   a =(unsigned char)(a|0x01);f_autosave = true;}
    if(MdcompOption->CheckBox2->Checked==true)
    	{   a =(unsigned char)(a|0x02);f_playloop = true;}
    if(MdcompOption->CheckBox3->Checked==true)
    	{   a =(unsigned char)(a|0x04);f_numberon = true;}
    if(MdcompOption->CheckBox4->Checked==true)
    	{   a =(unsigned char)(a|0x08);f_form_max = true;}

    switch(MdcompOption->RadioGroup1->ItemIndex)
    {
        case 0: a =(unsigned char)(a|0x10); break;
        case 1: a =(unsigned char)(a|0x20); break;
        case 2: a =(unsigned char)(a|0x40); break;
        default:a =(unsigned char)(a|0x10); break;
    }
    fontsize_r = MdcompOption->RadioGroup1->ItemIndex; //rev<20010322a>

	if(MdcompOption->RadioGroup2->ItemIndex==1)
    {
		a =(unsigned char)(a|0x80);  // 1==q7 (88va)
		f_q_def7 = true;
    }

    p1[16]= a;  //tOێ(16`31܂ŃtOp̏ꏊ)

    // v0.00.07Œǉ
    // 76543210
    // ???????c  <-ێ(c=checkbox)
    // ???????5  <-liYԍj
    a = 0;  //reset

    if(MdcompOption->CheckBox5->Checked==true)
    {   a =(unsigned char)(a|0x01);f_auto_lr = true;}

    p1[17]= a;  //tOێ(16`31܂ŃtOp̏ꏊ)


	AnsiString f1;
    f1 = ChangeFileExt(Application -> ExeName , ".cfg");

	//VKŃgC
  	if((cfghand = _rtl_creat(f1.c_str(), 0)) >= 0)
    {
	//cfg data=========
		_rtl_write( cfghand ,cfg_dat , CFGSIZE);   //write
        _rtl_close(cfghand);  //close
	//===========================
        RetTrueFalse = false;
    }
    else
    {
		//o̓t@C1
        Application->MessageBox("cfgJ܂\nݒύX͕ۑs",
            NULL,MB_ICONSTOP);
        RetTrueFalse = true;
	}

    //߂false
    //߂̂Ƃtrue
    return RetTrueFalse;

}
//---------------------------------------------------------------------------
bool __fastcall TForm1::RdCfgData()
{
    //mdcomp32.cfgݒǂݍ

    int cfghand;       //cfg̃nhۑp

    char cfg_dat[CFGSIZE+1];  //ۑf[^ꏊ
//    char *p1;         //ۑp|C^
//    unsigned char *p2;  //ۑp|C^

    bool RetTrueFalse; //true͎s,false

	AnsiString f1;
    f1 = ChangeFileExt(Application -> ExeName , ".cfg");

	//open
	if ((cfghand = _rtl_open(f1.c_str(), O_RDONLY | SH_DENYWR)) >= 0)
	{
	//cfg data荞=========
		_rtl_read( cfghand ,cfg_dat , CFGSIZE);   //read
        _rtl_close(cfghand);  //close
	//===========================

        //---cfg chk---
    	char d_mdcomp[] = "MDCOMP000";
    	if(strncmp(d_mdcomp,cfg_dat,strlen(d_mdcomp)) != 0)
        {
            Application->MessageBox("mdcomp32.cfg̃o[WΉ`",
                    NULL,MB_ICONSTOP);
            RetTrueFalse = true; //err
    	}
        else
        {   //wb_Ă
            unsigned char a;  //flagێp
            a = cfg_dat[16];  //tOێ(16`31܂ŃtOp̏ꏊ)

            // 76543210
            // qlmscccc  <-ێ(c=checkbox,s=font ,m=font ,l=font 
            // 2???4321  <-liYԍj
            if(a & 0x01){ f_autosave = true;}
            if(a & 0x02){ f_playloop = true;}
            if(a & 0x04){ f_numberon = true;}
            if(a & 0x08){ f_form_max = true;}
			if(a & 0x80){ f_q_def7 = true;}  //<20010322a> v0.00.05

            switch(a & 0x70)
            {
                case 0x10: fontsize_r = 0;break;  //
                case 0x20: fontsize_r = 1;break;  //
                case 0x40: fontsize_r = 2;break;  //
                default:   fontsize_r = 0;break;  //
            }

            a = cfg_dat[17];  //tOێ(16`31܂ŃtOp̏ꏊ)

            // 76543210
            // ???????c  <-ێ(c=checkbox,s=font ,m=font ,l=font 
            // ???????5  <-liYԍj
            if(a & 0x01){ f_auto_lr = true;}

            RetTrueFalse = false;  //ǂݍ߂
        }
    }
    //ǂݍ߂false
    //߂̂Ƃtrue
    return RetTrueFalse;
}
//------------------
void __fastcall TForm1::WMDropF(TMessage &Msg)
{
    //t@CDragDropŎ󂯓邽߂̏
    //ɈڂƂWM_DROPFILESbZ[W󂯎
    HDROP hDrop;    //\̎QƗphandle
    hDrop = (HANDLE)Msg.WParam;  //ʒu擾
    //hDropɍ\̂̈ʒu

    //MAXPATHBCBW<dir.h>Œ`
    char lpszFile[MAXPATH+1]; //filei[pobt@

    //Dropꂽfile͈ԍŏ0Ԗڂ󂯎
    UINT iFile=0;             //₢킹file̔ԍ
    UINT cb=MAXPATH;          //obt@̃TCY(260)
    DragQueryFile(hDrop, iFile, lpszFile, cb);

    //Ɏ擾t@C珈----------------
    SetForegroundWindow(Handle);
    Close1Click(this);  //{^

    //Close1ClickCancelƂ̑Ή<20011231p>v0.00.09
    if(f_CloseCancel==true)
    {
        //bZ[Wɑ΂I
        DragFinish(hDrop);   //ȂƂȂ
        Msg.Result = 0; //(0͏ƂӖ)
        return;
    }

    if(f_tmpcreate==true) //tȂ牉t߂
    {
        Form2->Timer1->Enabled=false;
		MediaPlayer1->Close();
        TmpClose();
    }

     OpenDialog1->FileName = lpszFile;  //filename copy

    //filẽI[vɎsꍇ̔ v0.00.05c <20010828p>
    bool f_fopen = true;   //s(true=,false=s)
    try
    {
     //<20020212>win2000 ----
	 Memo1 ->Lines->LoadFromFile(OpenDialog1->FileName.c_str());
	 //----------------------
	}
	catch(...)
	{
		Application->MessageBox("OPENł܂",NULL,MB_ICONSTOP);
		f_fopen = false;  //s
	}

    //I[vłꍇ
    if(f_fopen == true)
    {
        OpenFileAfter();  //fileopenɍs̊֐
    }
    else //łȂƂ
    {
        NotOpenFileAfter();  //fileopenłȂɍs̊֐
    }
    Application->ProcessMessages();
    //--------------------------------------------

    //bZ[Wɑ΂I
    DragFinish(hDrop);   //ȂƂȂ
    Msg.Result = 0; //(0͏ƂӖ)
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenFileAfter()
{
    //t@CI[vɍs֐
     strncpy(sourcefname,OpenDialog1->FileName.c_str(),MAXPATH);
     f_save = true;  /* Z[uł */
     f_saveend = true; /* Z[uƂɂ */
     StatusBar1->Panels->Items[2]->Text="";
     AnsiString f1;
     f1 = ChangeFileExt(OpenDialog1->FileName, ".mid");
     strncpy(midfname,f1.c_str(),MAXPATH-2);
     strncpy(bmidfname,f1.c_str(),MAXPATH-2);

	//<20020212p>win2000 -----
	int ssize;
	ssize = Memo1->Text.Length();
    //------------------------

     Memo2->Lines->Add(" -> J\[X̃TCY : "+IntToStr(ssize)+
         " oCg");
}
//------------------------------------------
void __fastcall TForm1::NotOpenFileAfter()
{
    //t@CI[vłȂƂɍs֐
    OpenDialog1->FileName = "";  //clear
    sourcefname[0]='\0';  //clear
    f_save = false;  /* Z[ułȂ */
    f_saveend = true; /* Z[uƂɂ */
    midfname[0] ='\0'; //clear
    bmidfname[0] ='\0'; //clear
    StatusBar1->Panels->Items[2]->Text="";
    Memo2->Lines->Add("ERR:t@CI[vłȂ.");
}
void __fastcall TForm1::SpeedButton12Click(TObject *Sender)
{
    //v0.00.07 <20010906>p
    if(S1->Checked==false)
    {
        S1->Checked=true;  //Auto Panpot
    }
    else
    {
        S1->Checked=false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::S1Click(TObject *Sender)
{
    if(SpeedButton12->Down==false)
    {
        SpeedButton12->Down=true; //Ez<20010906p>
        S1->Checked=true;
    }
    else
    {
        SpeedButton12->Down=false;
        S1->Checked=false;
    }

}
//---------------------------------------------------------------------------
int __fastcall TForm1::option_set()
{
    /* v0.00.08 op*/
    /*IvV͂tOݒ */
    char work[OPSETWORK+1];

    char *option_name[4] = {"q7def","q8def","autolr","manulr"};
    int option_value[4]  = {OP_Q7DEF,OP_Q8DEF,OP_AUTOLR,OP_MANULR};
    AnsiString As1;

    int retval;  /* ߂li[p (ret:0=noerr,<0=err)*/

    int ssize;  /* token̕擾 */

    gettoken(work,OPSETWORK);  /* '(' 𔭌 */
    if(work[0] != '(')
    {
        return -1;
    }


    while(1)
    {
        ssize = gettoken(work,OPSETWORK);

        for(int i=0;i<ssize;i++)   /* 啶珬֕ϊ */
        {
            work[i]=(unsigned char)tolower(work[i]);
            /* ShowMessage(work[i]); */
        }
        if(work[0] == ')'){retval = 0;break;}
        if(work[0] == ','){continue;}
        if(ssize <= 0){   retval = 22;break;} /* err return */

        bool f_op_ok = false;  /* IvVtrue */

        for(int i=0;i<4;i++)
        {
            if(strcmp(option_name[i],work)==0)
            {
                As1 = " [䖽]:";
                As1+=option_name[i];
                As1+="ɐݒ";
                Memo2->Lines->Add(As1);

                //IvVݒ肷֐
                option_checkon(option_value[i]);

                f_op_ok = true; /* IvV */
            }
        }

        if(f_op_ok == false)  /* NG */
        {
            retval = 23;  /* ߂Ȃ */
            break;
        }
    }
    return (retval);
}
//--------------------------------------------
void __fastcall TForm1::option_checkon(int flagno)
{
    switch(flagno)
    {
        case OP_Q7DEF: f_q_def7 = true; /* 88va݊<20010907p>v0.00.08 */
                for(int i=0;i<MAX_CH;i++)
                {   q_ch[i]  = Q_DEF-1;} /* q defalut(Q7:88VA݊) <20010322a> */
                    break;

        case OP_Q8DEF: f_q_def7 =false;
                for(int i=0;i<MAX_CH;i++)
                    {   q_ch[i]   = Q_DEF;} /* q  <20010321p> */
                 break; /* 88va݊<20010907p>v0.00.08 */

        case OP_AUTOLR:
            if(S1->Checked == false)
                {   S1->Checked = true;
                    SpeedButton12->Down=true;
                }
            Application->ProcessMessages();
                 break; /* E<20010907p>v0.00.08*/
        case OP_MANULR:
            if(S1->Checked == true)
                {   S1->Checked = false;
                    SpeedButton12->Down=false;
                }
            Application->ProcessMessages();
                break; /* E<20010907p>v0.00.08*/
    }
}
//-------------------------------------------
int __fastcall TForm1::copyr_set()
{
    /* v0.00.09 cr*/
    /* <20011231a> */

    char work[COPYRMAX+1];

    AnsiString As1;

    int retval;  /* ߂li[p (ret:0=noerr,<0=err)*/

    int ssize;  /* token̕擾 */

    ssize = gettoken(work,COPYRMAX);  /* '(' 𔭌 */
    if(work[0] != '(' || ssize == 0)
    {
        return -1;
    }
    /* ܂ŋ */

    ssize = gettoken(work,COPYRMAX); /* ' " '𔭌 */
    if(ssize <= 0){ return -1;}
    if(work[0] == ')') { return 0; }
    if(work[0] != '"') { return -1; }
    /* " ̏ */

    copyr_len = 0;  /*  */
//    retval = -1;  /* (0==noerror) */
    while(1)
    {
        if(*rdworkptr == 0x0d)
        {
            retval = -1;break;
        }
        if(*rdworkptr == '"')
        {
            rdworkptr++;  /* "̎ɂĂ */
            ssize = gettoken(work,COPYRMAX);
            //debug
            if(ssize <= 0){return 24;}  /* )ŏIĂȂ */
            if(work[0] == ')' )
            {   retval = 0; /* end */
                break;
            }
            else if(work[0] != '"' )
            {
                return -1; /* error */
            }
        }

        copyr_work[copyr_len]= *rdworkptr;
        copyr_len++;  rdworkptr++;
        if(copyr_len > COPYRMAX)
        {
            copyr_work[copyr_len]= '\0';  /* end code */
            As1 = " []:\"";
            As1+=copyr_work;
            As1+="<- MAX";
            Memo2->Lines->Add(As1);

            retval = 25;  /* over flow */
            break;
        }
    }

    if(retval == 0 && copyr_len >= 1)
    {
        f_copyr_sw = true;  /* 쌠\ ON */

        copyr_work[copyr_len]= '\0';  /* end code */
        As1 = " []:\"";
        As1+=copyr_work;
        As1+="\" ";
        As1+= "("+IntToStr(copyr_len)+" byte)";
        Memo2->Lines->Add(As1);
    }
    return (retval);
}
//-------------------------------------------
int __fastcall TForm1::sname_set()
{
    /* v0.00.10 sn*/
    /* <20020114p> */

    char work[SNAMEMAX+1];

    AnsiString As1;

    int retval;  /* ߂li[p (ret:0=noerr,<0=err)*/

    int ssize;  /* token̕擾 */

    ssize = gettoken(work,SNAMEMAX);  /* '(' 𔭌 */
    if(work[0] != '(' || ssize == 0)
    {
        return -1;
    }
    /* ܂ŋ */

    ssize = gettoken(work,SNAMEMAX); /* ' " '𔭌 */
    if(ssize <= 0){ return -1;}
    if(work[0] == ')') { return 0; }
    if(work[0] != '"') { return -1; }
    /* " ̏ */

    sname_len = 0;  /*  */
//    retval = -1;  /* (0==noerror) */
    while(1)
    {
        if(*rdworkptr == 0x0d)
        {
            retval = -1;break;
		}
		if(*rdworkptr == '"')
		{
			rdworkptr++;  /* "̎ɂĂ */
			ssize = gettoken(work,SNAMEMAX);
			//debug
			if(ssize <= 0){return 26;}  /* )ŏIĂȂ */
			if(work[0] == ')' )
			{   retval = 0; /* end */
				break;
			}
			else if(work[0] != '"' )
			{
				return -1; /* error */
			}
		}

		sname_work[sname_len]= *rdworkptr;
		sname_len++;  rdworkptr++;
		if(sname_len > SNAMEMAX)
		{
			sname_work[sname_len]= '\0';  /* end code */
			As1 = " [V[PX]:\"";
			As1+=sname_work;
			As1+="<- MAX";
			Memo2->Lines->Add(As1);

			retval = 27;  /* over flow */
			break;
		}
	}

	if(retval == 0 && sname_len >= 1)
	{
		f_sname_sw = true;  /* 쌠\ ON */

		sname_work[sname_len]= '\0';  /* end code */
		As1 = " [V[PX]:\"";
		As1+=sname_work;
		As1+="\" ";
		As1+= "("+IntToStr(sname_len)+" byte)";
		Memo2->Lines->Add(As1);
	}
	return (retval);
}
//--------------------------------------
int __fastcall TForm1::gettoken(char *p,int bufsize)
{
	bool f_loopout = false;
	int ssize = 0;  /*token size */
	int rdcnt; /* ǂݍ݃TCY */
	while(f_loopout == false)
	{
		if(strlen((char*)rdworkptr) <= 0 || *rdworkptr == 0x0d)
		{
			rdcnt = rd1line();
			rdworkptr = rdwork;
			if(rdcnt <= 0) break;
		}

		/*󔒂TABJbg*/
		while(*rdworkptr == ' ' || *rdworkptr == 0x09)
		{
			rdworkptr++;
		}

		if(*rdworkptr == 0x0d)
		{
			continue;
		}

		/*󔒂TABy0x0d܂ŕ*/
		bool f_loopout2 = false;
		int  cnt = strlen((char*)rdworkptr); /*Jn擾*/

		switch(*rdworkptr)
		{
			case '(':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=true;
					*p= '\0';  /*end mark*/
					break;
			case ')':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=true;
					*p= '\0';  /*end mark*/
					break;
			case ',':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=true;
					*p = '\0';  /*end mark*/
					break;
			/* cr߂ɑΉ邽߂ " 1ƂĐ؂o <20011231p>v0.00.09*/
			case '"':*p = *rdworkptr;p++;rdworkptr++;ssize++;f_loopout2=true;
					*p = '\0';  /*end mark*/
					break;
		}

		while(f_loopout2 == false)
		{
			if(*rdworkptr == ' ')f_loopout2=true;
			if(*rdworkptr == 0x09)f_loopout2=true;
			if(*rdworkptr == 0x0d)f_loopout2=true;
			if(*rdworkptr == 0x0a)f_loopout2=true;
			if(*rdworkptr == ',')f_loopout2=true;
			if(*rdworkptr == ')')f_loopout2=true;
			if(ssize >= bufsize)f_loopout2=true;
			if(ssize >= cnt)f_loopout2 =true;
			if(f_loopout2 == false)
			{
				*p = *rdworkptr;
				p++;
				*p = '\0'; /*KŌ0*/
				rdworkptr++;
				ssize++;
			}

		}
		f_loopout = true; /*[vI*/
	}
	return (ssize);
}
//------------------------------------

void __fastcall TForm1::Memo1Change(TObject *Sender)
{
//<20020212p> win2000----
	f_saveend = false; /* saveĂȂƂɂ */
	StatusBar1->Panels->Items[2]->Text="ύX";
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Memo1KeyDown(TObject *Sender, WORD &Key,
	  TShiftState Shift)
{
	//<20020212p>win2000
	if( (Shift.Contains(ssShift)) && Key == VK_INSERT)
	{
		Paste1->Click();
		Key=NULL;  //cancel
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Memo1KeyUp(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
	//<20020212p> win2000 --------------
	if( (Shift.Contains(ssShift)) && Key == VK_INSERT)
    {
//    	Paste1->Click();
	    Key=NULL;  //cancel
    }
	else if(Shift.Contains(ssShift) == false &&
    			Shift.Contains(ssAlt) == false &&
                Shift.Contains(ssCtrl)==  false &&
                Key == VK_INSERT)
    {
    	if(OverWrite == false)
        {	OverWrite = true;}
        else
        {	OverWrite = false;}

		//OverWritemidmain.hŒ`
		//ԕ\
/*
		if(OverWrite==false)
		{
				StatusBar1->Panels->Items[4]->Text="}";
		}
		else
		{
				StatusBar1->Panels->Items[4]->Text="㏑";
		}
*/
	}
	OutPutCursorPos();	

}
//---------------------------------------------------------------------------




void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	if(abaksttim != 0){	abaksttim--; } //Vю
	if(abaktim != 0){ abaktim--;}      //bakԊu

	//debug
    //Form1->Caption=IntToStr(abaksttim)+":"+IntToStr(abaktim);

	if(abaksttim == 0 && abaktim == 0)
    {
		Timer1->Enabled = false;
		//ShowMessage("point -1");
    	//obNAbv
		if(f_autobak == true && tmp_hand >= 0)
        {
			//debug
			//ShowMessage("point 0");
			AnsiString ca1;
            ca1 = Form1->Caption;

            Form1->Caption = " obNAbv";

	       	_rtl_close(tmp_hand);  //ɃN[Y

			//--<20020610p> obNAbvp v0.00.10a (GUI)---
			//tmptH_擾
		    AnsiString f1;
		    char tmppath[MAX_PATH+2];
		    if(GetTempPath(MAX_PATH,tmppath)<=0)
		    {
		    	//TempPathG[̏
		    }
		    f1=tmppath;
		    f1+="!!mdcomp32.tmp";

			Memo1->Lines->SaveToFile(f1.c_str());

			//ăI[v
			if ((tmp_hand = _rtl_open(f1.c_str(), O_RDONLY | SH_DENYRW)) >= 0)
			{
		    	//openł
			}
			else
		    {
				//openłȂ
		    }
			//debug
			//ShowMessage("backup");
			Form1->Caption = ca1;  //Ƃcaption ɂǂ
        }
		abaksttim = IDLATBTIM;  //Vю
        abaktim   = ATBAKTIM;   //backupԊu
		Timer1->Enabled = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	abaksttim = IDLATBTIM;   //}EX𓮂̂ŗVт߂

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
	//tmpN[Y폜
	if(f_autobak == true && tmp_hand >= 0)
    {
		_rtl_close(tmp_hand);  //close

	    AnsiString f1;
	    char tmppath[MAX_PATH+2];
	    if(GetTempPath(MAX_PATH,tmppath)<=0)
	    {
	    	//TempPathG[̏
	    }
		f1=tmppath;
		f1+="!!mdcomp32.tmp";
		if(DeleteFile(f1)==false)
        {
        	//폜s
			Application->MessageBox("!!mdcomp32.tmp폜s",NULL,MB_ICONSTOP);
        }
	}
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Memo2DblClick(TObject *Sender)
{
	AnsiString as1,as2;

	int gyo=0;
	int m2cnt;
	m2cnt = Memo2->Lines->Count;

	if(m2cnt > 1)
	{
		int y;
		y = Memo2->Perform(EM_LINEFROMCHAR, Memo2->SelStart, 0);
		as1=Memo2->Lines->Strings[y];  //_uNbNs
		as2=as1.TrimLeft();
		as1=as2;
		as2=as1.SubString(1, as1.AnsiPos(" ")-1);
		if( as2=="ERR")
		{
			as2=as1.SubString(as1.AnsiPos("[")+1,5); //5̂

			try
			{
				gyo = StrToInt(as2);
			}
			catch (...)
			{
				//
			}
			if(gyo >= 1) { gyo--;}  //adjust
			Memo1->SetFocus();
			Memo1->SelStart=Memo1->Perform(EM_LINEINDEX,gyo,0);
			Memo1->Perform(EM_SCROLLCARET,0,0);  //J[\ʒu܂ŃXN[
		}
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Memo1MouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	OutPutCursorPos();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::fmcomp1Click(TObject *Sender)
{
	//fmcompf[^t@Cɏo
	//v1.01.00 (2017/09/07)
	fmdat->Clear();         // wb_Ŏgp錾,formcloseŉ

	// midi comp32
	int c = 0; /* o͂gbN */

	//<20010127p>
	int ret_val; /* G[ԍ */

	//RpC------------
	RdFileLineCnt=0;  //rd1lineG~[Vp

	f_remskip = false; //<20010126a>RgJnƏȈ
	Memo2->Text=""; /* crear text */

	f_nomidiout = true; //<20170907p>truemidioutȂ

	ret_val = midmain();      // standard midi file create

	f_nomidiout = false; //<20170907p>truemidioutȂ

	// <20011231p> v0.00.09 SMF쐬ERR֒mP
	if(ret_val == 0){ f_errcreate = false; }
		else {  f_errcreate = true; }
	//-----------------------

	for(int i=0;i<MAX_CH;i++)
	{
		if(chxcnt[i] > 0) c++;
	}

	if(c == 0)return; /* ret */

	if(SaveDialog2->Execute() == true)
	{   //t@Cw肳ꂽƂs
		AnsiString as1;
		as1 = SaveDialog2->FileName;
		try
		{
			fmdat->SaveToFile(as1);
		}
		catch(...)
		{
		//
		}
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	//fmcompf[^o͗p 
	delete fmdat;

}
//---------------------------------------------------------------------------

